      PROGRAM  MAIN
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION XPAR(100), NPAR(100)
* ((((      LUND stuff
      COMMON / LUDAT1 / MSTU,PARU,MSTJ,PARJ
      REAL PARU(200),PARJ(200) 
      INTEGER MSTU(200),MSTJ(200)
* ))))  end LUND stuff

* For internal histogramming package GLIBK
      COMMON / CGLIB / BLIBK(50000)
      SAVE   / CGLIB /
      SAVE  
      NOUT=16    
      OPEN(NOUT,file='pro.output')
      CALL GLIMIT(20000)
      CALL GOUTPU(NOUT)  
* End of initialization of internal histogramming package GLIBK

* ((((      LUND stuff
      mstu(11)=nout 
* ))))  end LUND stuff

* =============================================================
* Prepare the input parameters for KORALW
      NPAR(1)=1    ! KeyRad = 1000*KeyCul +100*KeyNLL +10*KeyFSR +KeyISR  
      NPAR(2)=1011 ! KeyPhy = 100000*KeyWu +10000*KeyRed +1000*KeySpn 
                   !                       +100*KeyZet +10*KeyMas +KeyBra  
      NPAR(3)=10   ! KeyTek = 100*KeySmp +10*KeyRnd +KeyWgt
      NPAR(4)=10000! KeyMis = 10000*KeyWon +1000*KeyZon+100*KeyAcc 
                   !                       +10*Key4f +KeyMix
      NPAR(5)=0    ! KEYDWM    W- decay: 7=(ev), 0=all ch.   
      NPAR(6)=0    ! KEYDWP    W+ decay: 7=(ev), 0=all ch.  

      NPAR(7)=NOUT ! NOUT      Output unit number, for Nout.LE.0, Nout=16

      NPAR(21)=0   ! JAK1      Decay mode tau+
      NPAR(22)=0   ! JAK2      Decay mode tau-
      NPAR(23)=1   ! ITDKRC    Bremsstrahlung switch in Tauola 
      NPAR(24)=1   ! IFPHOT    PHOTOS switch
      NPAR(25)=1   ! IFHADM    Hadronisation W-
      NPAR(26)=1   ! IFHADP    Hadronisation W+IFHADP
   
      XPAR(1)=180D0      ! CMSENE CMS total energy  
      XPAR(2)=1.16639D-5 ! GFERMI Fermi Constant  
      XPAR(3)=128.07D0   ! ALFWIN alpha QED at WW tresh. scale (inverse) 
      XPAR(4)=91.1888d0  ! AMAZ   Z mass   
      XPAR(5)=2.4974d0   ! GAMMZ  Z width      
      XPAR(6)=80.230d0   ! AMAW   W mass 
      XPAR(7)=-2.03d0    ! GAMMW  W with, For GAMMW<0 RECALCULATED inside program
      XPAR(8)=1D-6       ! VVMIN  Photon spectrum parameter
      XPAR(9)=0.99D0     ! VVMAX  Photon spectrum parameter
      XPAR(10)=-1D0      ! WTMAX  max weight for reject. 
                         !        WTMAX<0 = default setting
      cmsene=xpar(1)     ! input for KORWAN 
* End of setting parameters

*     KORALW initialisation               ================   
      CALL KORALW(-1,XPAR,NPAR)    
* end KORALW initialisation               ================   

* KORALW main loop
      DO 100 I=1,1000
        CALL KORALW( 0,XPAR,NPAR)    

* ((((      LUND stuff
        IF(I.LE.10) CALL lulist(2)
* ))))  end LUND stuff

  100 CONTINUE         
* End KORALW main loop

*     final printouts of KORALW           ================ 
      CALL KORALW( 1,XPAR,NPAR)    
* some outputs of KORALW 
      XSECT = xpar(20)
      ERSECT= xpar(21)
* end final printouts of KORALW           ================ 



* SemiAnalytical O(alf2)exp. , KORWAN
      keypho=0
      keyacc=1
      call korwan(cmsene**2,0d0,1d0,keypho,keyacc,Xtot,erra)
      keypho=302 
      keyacc=1
      call korwan(cmsene**2,0d0,1d0,keypho,keyacc,Xtot2e,errabs)
* End SemiAnalytical O(alf2)exp. , KORWAN

* Final printouts of demo

      WRITE(NOUT,'(A60)') '============ DEMO ============'
      WRITE(NOUT,*) 
      WRITE(NOUT,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
     $     xsect,ersect, 'MC Best, XPAR, KORALW'
      WRITE(NOUT,*) 
      WRITE(NOUT,'(A60)') 'WARNING:   SemiAnal results make phys. sense'
      WRITE(NOUT,'(A60)') '           for KeyZon.eq.0 & key4f.eq.0     '
      WRITE(NOUT,'(A60)') 'otherwise: they provide info on crude distr.'
      WRITE(NOUT,*) 
      WRITE(NOUT,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
     $     Xtot2e,errabs,'SemiAnal O(alf2)exp.LL, KORWAN'
      WRITE(NOUT,*)
      WRITE(NOUT,'(A60)') '========== End DEMO =========='

      WRITE(6,'(A60)') '============ DEMO ============'
      WRITE(6,*) 
      WRITE(6,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
     $     xsect,ersect, 'MC Best, XPAR, KORALW'
      WRITE(6,*) 
      WRITE(6,'(A60)') 'WARNING:   SemiAnal results make phys. sense'
      WRITE(6,'(A60)') '           for KeyZon.eq.0 & key4f.eq.0     '
      WRITE(6,'(A60)') 'otherwise: they provide info on crude distr.'
      WRITE(6,*) 
      WRITE(6,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
     $     Xtot,erra,'SemiAnal Born, KORWAN'
      WRITE(6,*)
      WRITE(6,*) 
      WRITE(6,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
     $     Xtot2e,errabs,'SemiAnal O(alf2)exp.LL, KORWAN'
      WRITE(6,*)
      WRITE(6,'(A60)') '========== End DEMO =========='

      END        

    
