      subroutine spacegen(mode,itype,svar,sprim,fakir)
********************************************************
! ================================================================
! mode=0                                                         =
!        generates 4-momenta accordingly to itype of generation, =
!        writes them down into / bormom/.                        =
!        calculates jacobian (out from 4-momenta from / bormom/) =
! mode=1                                                         =
!        calculates jacobian (out from 4-momentafrom / bormom/)  =
!        for itype generation branch                             =
! ================================================================
      implicit real*8 (a-h,o-z)
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF 
      COMMON / WEKIN2 / AMAW,GAMMW,GMU,ALPHAW 
      COMMON / MATPAR / PI,CEULER       
      COMMON / SSTHE / S1,S2                 
      COMMON / ANGLES / COSTHE,PHI,COSDE1,PHI1,COSDE2,PHI2
      COMMON / DECAYS / IFLAV(4), AMDEC(4), BR(2), BREL
      common / bormom / bq1(4),bq2(4),bp1(4),bp2(4),bp3(4),bp4(4)
      save   / bormom /
! This common can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      save  / WEKING /,/ WEKIN2 /,/ MATPAR /,/ KeyKey/
      save  / SSTHE /,/ ANGLES /,/ DECAYS /
      parameter (NRCH=100)
      common /kanalarz/ fakI(NRCH),ikan,MRCHAN,NRCHAN
      save  /kanalarz/
      dimension amdet(4)
      common /nevik/ nevtru,ifprint
      save nevik
      SAVE
!
      ifprint=0
!      =====================================
!      ====================================
       IF (ITYPE.GT.62.and.itype.lt.70) THEN
!      =====================================
!      =====================================
!
        IRODZ=ITYPE-62
        igcl=7
      IF     (IRODZ.EQ.1) THEN
       igcl=5
!       if (nevtru.eq.-236) ifprint=1
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP3,amdec(3),bP2,amdec(2))
       ifprint=0
      elseIF (IRODZ.EQ.2) THEN
       igcl=6
!       if (nevtru.eq.-269) ifprint=1
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP3,amdec(3),bP2,amdec(2),bP1,amdec(1),bP4,amdec(4))
       ifprint=0
      elseIF (IRODZ.EQ.3) THEN
       igcl=5
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP3,amdec(3),bP2,amdec(2),bP1,amdec(1),bP4,amdec(4))
      elseIF (IRODZ.EQ.4) THEN
       igcl=6
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP3,amdec(3),bP2,amdec(2))
      elseIF (IRODZ.EQ.5) THEN
       igcl=1
       CALL kinchce(IGCL,MODE,Amaw,gammw,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      elseIF (IRODZ.EQ.6) THEN
       igcl=1
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      elseIF (IRODZ.EQ.7) THEN
       igcl=1
       CALL kinchce(IGCL,MODE,Amaz,amaz,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================
!      =====================================
!      =====================================
!      =====================================
       IF (ITYPE.GT.58.and.itype.lt.63) THEN
!      =====================================
!      =====================================
!
        IRODZ=ITYPE-58
        igcl=10
      IF     (IRODZ.EQ.1) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,0.d0,SPRIM,fakir,
     $     bP2,amdec(2),bP3,amdec(3),bP1,amdec(1),bP4,amdec(4))
      ELSEIF (IRODZ.EQ.2) THEN
       if (nevtru.eq.-226) ifprint=1
       CALL kinchce(IGCL,MODE,ADUM,GDUM,1d0,SPRIM,fakir,
     $     bP3,amdec(3),bP2,amdec(2),bP1,amdec(1),bP4,amdec(4))
       ifprint=0
      ELSEIF (IRODZ.EQ.3) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,0d0,SPRIM,fakir,
     $     bP4,amdec(4),bP1,amdec(1),bP2,amdec(2),bP3,amdec(3))
      ELSEIF (IRODZ.EQ.4) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,1d0,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP2,amdec(2),bP3,amdec(3))
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================

!      =====================================
!      =====================================
       IF (ITYPE.GT.54.and.itype.lt.59) THEN
!      =====================================
!      =====================================
!
        IRODZ=ITYPE-54
        igcl=9
      IF     (IRODZ.EQ.1) THEN
       CALL kinchce(IGCL,MODE,AMAZ,-GAMMZ,0D0,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP3,amdec(3),bP2,amdec(2))
      elseIF (IRODZ.EQ.2) THEN
       CALL kinchce(IGCL,MODE,AMAZ,-GAMMZ,1D0,SPRIM,fakir,
     $     bP4,amdec(4),bP1,amdec(1),bP3,amdec(3),bP2,amdec(2))
      ELSEIF (IRODZ.EQ.3) THEN
       if (nevtru.eq.-7) ifprint=1
       CALL kinchce(IGCL,MODE,AMAZ,-GAMMZ,0D0,SPRIM,fakir,
     $     bP3,amdec(3),bP2,amdec(2),bP1,amdec(1),bP4,amdec(4))
       ifprint=0
      ELSEIF (IRODZ.EQ.4) THEN
       if (nevtru.eq.-43026) ifprint=1
       CALL kinchce(IGCL,MODE,AMAZ,-GAMMZ,1D0,SPRIM,fakir,
     $     bP2,amdec(2),bP3,amdec(3),bP1,amdec(1),bP4,amdec(4))
       ifprint=0
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================

!      ====================================
       IF (ITYPE.GT.50.and.itype.lt.55) THEN
!      =====================================
!      =====================================
!
        IRODZ=ITYPE-50
        igcl=7
      IF     (IRODZ.EQ.1) THEN
       igcl=5
!       if (nevtru.eq.-236) ifprint=1
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP3,amdec(3),bP4,amdec(4),bP1,amdec(1),bP2,amdec(2))
       ifprint=0
      elseIF (IRODZ.EQ.2) THEN
       igcl=6
!       if (nevtru.eq.-269) ifprint=1
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
       ifprint=0
      elseIF (IRODZ.EQ.3) THEN
       igcl=5
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      elseIF (IRODZ.EQ.4) THEN
       igcl=6
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP3,amdec(3),bP4,amdec(4),bP1,amdec(1),bP2,amdec(2))
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================

!      =====================================
!      =====================================
       IF (ITYPE.GT.46.and.itype.lt.51) THEN
!      =====================================
!      =====================================
!
        IRODZ=ITYPE-46
        igcl=8
      IF     (IRODZ.EQ.1) THEN
       CALL kinchce(IGCL,MODE,AMAZ,-gammz,0D0,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      elseIF (IRODZ.EQ.2) THEN
       CALL kinchce(IGCL,MODE,AMAZ,-gammz,1D0,SPRIM,fakir,
     $     bP2,amdec(2),bP1,amdec(1),bP3,amdec(3),bP4,amdec(4))
      ELSEIF (IRODZ.EQ.3) THEN
       CALL kinchce(IGCL,MODE,AMAZ,-gammz,0D0,SPRIM,fakir,
     $     bP3,amdec(3),bP4,amdec(4),bP1,amdec(1),bP2,amdec(2))
      ELSEIF (IRODZ.EQ.4) THEN
       CALL kinchce(IGCL,MODE,AMAZ,-gammz,1D0,SPRIM,fakir,
     $     bP4,amdec(4),bP3,amdec(3),bP1,amdec(1),bP2,amdec(2))
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================
       IF (ITYPE.GT.42.and.itype.lt.47) THEN
!      =====================================
!      =====================================
!
        IRODZ=ITYPE-42
        igcl=10
      IF     (IRODZ.EQ.1) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,0.d0,SPRIM,fakir,
     $     bP4,amdec(4),bP3,amdec(3),bP1,amdec(1),bP2,amdec(2))
      ELSEIF (IRODZ.EQ.2) THEN
       if (nevtru.eq.-226) ifprint=1
       CALL kinchce(IGCL,MODE,ADUM,GDUM,1d0,SPRIM,fakir,
     $     bP3,amdec(3),bP4,amdec(4),bP1,amdec(1),bP2,amdec(2))
       ifprint=0
      ELSEIF (IRODZ.EQ.3) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,0d0,SPRIM,fakir,
     $     bP2,amdec(2),bP1,amdec(1),bP3,amdec(3),bP4,amdec(4))
      ELSEIF (IRODZ.EQ.4) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,1d0,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================

!      =====================================
!      =====================================
       IF (ITYPE.GT.38.and.itype.lt.43) THEN
!      =====================================
!      =====================================
!
        IRODZ=ITYPE-38
        igcl=9
      IF     (IRODZ.EQ.1) THEN
       if (nevtru.eq.-3320) ifprint=1
       CALL kinchce(IGCL,MODE,AMAZ,-GAMMZ,0D0,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
       ifprint=0
      elseIF (IRODZ.EQ.2) THEN
       CALL kinchce(IGCL,MODE,AMAZ,-GAMMZ,1D0,SPRIM,fakir,
     $     bP2,amdec(2),bP1,amdec(1),bP3,amdec(3),bP4,amdec(4))
      ELSEIF (IRODZ.EQ.3) THEN
       if (nevtru.eq.-7) ifprint=1
       CALL kinchce(IGCL,MODE,AMAZ,-GAMMZ,0D0,SPRIM,fakir,
     $     bP3,amdec(3),bP4,amdec(4),bP1,amdec(1),bP2,amdec(2))
       ifprint=0
      ELSEIF (IRODZ.EQ.4) THEN
       if (nevtru.eq.-43026) ifprint=1
       CALL kinchce(IGCL,MODE,AMAZ,-GAMMZ,1D0,SPRIM,fakir,
     $     bP4,amdec(4),bP3,amdec(3),bP1,amdec(1),bP2,amdec(2))
       ifprint=0
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================

!      =====================================
!      =====================================
       IF (ITYPE.GT.30.and.itype.lt.39) THEN
!      =====================================
!      =====================================
!
        IRODZ=ITYPE-30
        igcl=8
      IF     (IRODZ.EQ.1) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,0D0,SPRIM,fakir,
     $     bP1,amdec(1),bP3,amdec(3),bP2,amdec(2),bP4,amdec(4))
      elseIF (IRODZ.EQ.2) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,0D0,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP2,amdec(2),bP3,amdec(3))
      ELSEIF (IRODZ.EQ.3) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,1D0,SPRIM,fakir,
     $     bP2,amdec(2),bP3,amdec(3),bP1,amdec(1),bP4,amdec(4))
      ELSEIF (IRODZ.EQ.4) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,1D0,SPRIM,fakir,
     $     bP2,amdec(2),bP4,amdec(4),bP1,amdec(1),bP3,amdec(3))

      ELSEIF (IRODZ.EQ.5) THEN
         if (nevtru.eq.-80  ) ifprint=1
         if (nevtru.eq.-109856  ) write(*,*) nevtru
       CALL kinchce(IGCL,MODE,AMAW,amaw,0D0,SPRIM,fakir,
     $     bP3,amdec(3),bP1,amdec(1),bP4,amdec(4),bP2,amdec(2))
      ELSEIF (IRODZ.EQ.6) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,0D0,SPRIM,fakir,
     $     bP3,amdec(3),bP2,amdec(2),bP4,amdec(4),bP1,amdec(1))
      ELSEIF (IRODZ.EQ.7) THEN
      if (nevtru.eq.-113526) write(*,*) 'nevtru=',nevtru
      if (nevtru.eq.-24) ifprint=1
       CALL kinchce(IGCL,MODE,AMAW,amaw,1D0,SPRIM,fakir,
     $     bP4,amdec(4),bP1,amdec(1),bP3,amdec(3),bP2,amdec(2))
      ELSEIF (IRODZ.EQ.8) THEN
!       if (nevtru.eq.-17170) ifprint=1
       if (nevtru.eq.-9743) ifprint=1
       CALL kinchce(IGCL,MODE,AMAW,amaw,1D0,SPRIM,fakir,
     $     bP4,amdec(4),bP2,amdec(2),bP3,amdec(3),bP1,amdec(1))
       ifprint=0
!      if (mode.eq.0) write(*,*) bp4
!      if (mode.eq.0) write(*,*) bp2
 !     if (mode.eq.0) write(*,*) bp3
!      if (mode.eq.0) write(*,*) bp1
  !    if (mode.eq.0) write(*,*) '==========================='
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================
!      =====================================
!      ====================================
       IF (ITYPE.GT.20.and.itype.lt.31) THEN
!      =====================================
!      =====================================
!
        IRODZ=ITYPE-20
        igcl=7
      IF     (IRODZ.EQ.1) THEN
       igcl=3
       if (nevtru.eq.-8191) ifprint=1
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
       ifprint=0
      elseIF (IRODZ.EQ.2) THEN
       igcl=3
       CALL kinchce(IGCL,MODE,Amaz,gammz,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP2,amdec(2),bP3,amdec(3))
      ELSEIF (IRODZ.EQ.3) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP4,amdec(4),bP3,amdec(3),bP1,amdec(1),bP2,amdec(2))
      ELSEIF (IRODZ.EQ.4) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP3,amdec(3),bP4,amdec(4),bP1,amdec(1),bP2,amdec(2))
      ELSEIF (IRODZ.EQ.5) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP2,amdec(2),bP1,amdec(1),bP3,amdec(3),bP4,amdec(4))
      ELSEIF (IRODZ.EQ.6) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      ELSEIF (IRODZ.EQ.7) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP2,amdec(2),bP3,amdec(3),bP4,amdec(4),bP1,amdec(1))
      ELSEIF (IRODZ.EQ.8) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP3,amdec(3),bP2,amdec(2),bP4,amdec(4),bP1,amdec(1))
      ELSEIF (IRODZ.EQ.9) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP4,amdec(4),bP1,amdec(1),bP2,amdec(2),bP3,amdec(3))
      ELSEIF (IRODZ.EQ.10) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP2,amdec(2),bP3,amdec(3))
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================

!      =====================================
!      =====================================
       IF (ITYPE.GT.10.and.itype.lt.21) THEN
!      =====================================
!      =====================================
        igcl=8
        IRODZ=ITYPE-10
      IF     (IRODZ.EQ.1) THEN
       CALL kinchce(IGCL,MODE,AMAW,GAMMW,0D0,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      ELSEIF (IRODZ.EQ.2) THEN
       CALL kinchce(IGCL,MODE,AMAZ,GAMMZ,0D0,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP2,amdec(2),bP3,amdec(3))
      ELSEIF (IRODZ.EQ.3) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,0D0,SPRIM,fakir,
     $     bP4,amdec(4),bP3,amdec(3),bP2,amdec(2),bP1,amdec(1))
      ELSEIF (IRODZ.EQ.4) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,0D0,SPRIM,fakir,
     $     bP1,amdec(1),bP3,amdec(3),bP2,amdec(2),bP4,amdec(4))
      ELSEIF (IRODZ.EQ.5) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,0D0,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP2,amdec(2),bP3,amdec(3))

      ELSEIF (IRODZ.EQ.6) THEN
       CALL kinchce(IGCL,MODE,AMAW,GAMMW,1D0,SPRIM,fakir,
     $     bP4,amdec(4),bP3,amdec(3),bP2,amdec(2),bP1,amdec(1))
      ELSEIF (IRODZ.EQ.7) THEN
       CALL kinchce(IGCL,MODE,AMAZ,GAMMZ,1D0,SPRIM,fakir,
     $     bP4,amdec(4),bP1,amdec(1),bP3,amdec(3),bP2,amdec(2))
      ELSEIF (IRODZ.EQ.8) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,1D0,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      ELSEIF (IRODZ.EQ.9) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,1D0,SPRIM,fakir,
     $     bP4,amdec(4),bP2,amdec(2),bP3,amdec(3),bP1,amdec(1))
      ELSEIF (IRODZ.EQ.10) THEN
       CALL kinchce(IGCL,MODE,AMAW,amaw,1D0,SPRIM,fakir,
     $     bP4,amdec(4),bP1,amdec(1),bP3,amdec(3),bP2,amdec(2))

      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif
        RETURN
       ENDIF
!      =====================================
!      =====================================
       IF (ITYPE.GT. 6.and.itype.lt.11) THEN
!      =====================================
!      =====================================
        igcl=7
        IRODZ=ITYPE-6
      IF     (IRODZ.EQ.1) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP2,amdec(2),bP3,amdec(3))
      ELSEIF (IRODZ.EQ.2) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP4,amdec(4),bP1,amdec(1),bP2,amdec(2),bP3,amdec(3))
      ELSEIF (IRODZ.EQ.3) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP2,amdec(2),bP3,amdec(3),bP4,amdec(4),bP1,amdec(1))
      ELSEIF (IRODZ.EQ.4) THEN
       CALL kinchce(IGCL,MODE,ADUM,GDUM,PDUM,SPRIM,fakir,
     $     bP3,amdec(3),bP2,amdec(2),bP4,amdec(4),bP1,amdec(1))
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================
       IF (ITYPE.GT. 0.and.itype.lt. 7) THEN
!      =====================================
!      =====================================
!
        IRODZ=ITYPE
      IF     (IRODZ.EQ.1) THEN
       igcl=1    
       CALL kinchce(IGCL,MODE,Amaw,gammw,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      elseIF (IRODZ.EQ.2) THEN
       igcl=2    
       CALL kinchce(IGCL,MODE,Amaw*5,gammw,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      elseIF (IRODZ.EQ.3) THEN
       igcl=3
       CALL kinchce(IGCL,MODE,amaz,gammz,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP3,amdec(3),bP2,amdec(2))
      elseIF (IRODZ.EQ.4) THEN
       igcl=4
       CALL kinchce(IGCL,MODE,amaw,gammw,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP2,amdec(2),bP3,amdec(3),bP4,amdec(4))
      elseIF (IRODZ.EQ.5) THEN
       igcl=4
       CALL kinchce(IGCL,MODE,amaz,gammz,svar,SPRIM,fakir,
     $     bP1,amdec(1),bP4,amdec(4),bP3,amdec(3),bP2,amdec(2))
      elseIF (IRODZ.EQ.6) THEN
       igcl=4
       CALL kinchce(IGCL,MODE,amaz,gammz,svar,SPRIM,fakir,
     $     bP3,amdec(3),bP2,amdec(2),bP1,amdec(1),bP4,amdec(4))
      ENDIF
c.. 4momenta for born, in effective CMS, z+ along qeff1
      if (mode.eq.0) then
      do i=1,4
        bq1(i)=bp1(i)+bp2(i)
        bq2(i)=bp3(i)+bp4(i)
      enddo
      endif 
        RETURN
       ENDIF
!      =====================================
!      =====================================
   
       write(*,*) 'spacegen; wrong ITYPE=',itype
       stop
!!!
      end

      subroutine kinchce(IGCL,MODE,AMAW,GAMMW,pr,SPRIM,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      dimension bp1(4),bp2(4),bp3(4),bp4(4)
      IF (IGCL.eq.10) then
        IF(MODE.EQ.0) THEN      
         CALL KINbre(1,pr,SPRIM,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
        elseif(MODE.EQ.1) THEN
         CALL rKINbre(1,pr,SPRIM,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
        else
         write(*,*) 'kinche; wrong mode=',mode
         stop
        endif
      elseIF (IGCL.eq.9) then
        IF(MODE.EQ.0) THEN      
         CALL KINT(1,AMAW,GAMMW,pr,SPRIM,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
        elseif(MODE.EQ.1) THEN
         CALL rKINT(1,AMAW,GAMMW,pr,SPRIM,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
        else
         write(*,*) 'kinche; wrong mode=',mode
         stop
        endif
      elseIF (IGCL.eq.8) then
        IF(MODE.EQ.0) THEN      
         CALL KINT(0,AMAW,GAMMW,pr,SPRIM,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
        elseif(MODE.EQ.1) THEN
         CALL rKINT(0,AMAW,GAMMW,pr,SPRIM,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
        else
         write(*,*) 'kinche; wrong mode=',mode
         stop
        endif
      elseIF (IGCL.eq.7) then
        IF(MODE.EQ.0) THEN      
         CALL KINbre(0,pr,SPRIM,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
        elseif(MODE.EQ.1) THEN
         CALL rKINbre(0,pr,SPRIM,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
        else
         write(*,*) 'kinche; wrong mode=',mode
         stop
        endif
      elseIF (IGCL.lt.7) then
        svar=pr
        call spaceold(mode,igcl,AMAW,GAMMW,svar,sprim,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
      else
       write(*,*) 'kinche; wrong igcl=',igcl 
       stop
      endif
      end

      subroutine spaceold(mode,itype,amx,gamx,svar,sprim,fakir,
     $     bP1,amd1,bP2,amd2,bP3,amd3,bP4,amd4)
********************************************************
! ================================================================
! mode=0                                                         =
!        generates 4-momenta accordingly to itype of generation, =
!        writes them down into / bormom/.                        =
!        calculates jacobian (out from 4-momenta from / bormom/) =
! mode=1                                                         =
!        calculates jacobian (out from 4-momentafrom / bormom/)  =
!        for itype generation branch                             =
! ================================================================
      implicit real*8 (a-h,o-z)
! we take just amel from this common
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF 
      COMMON / MATPAR / PI,CEULER       
      COMMON / SSTHE / S1,S2                 
      COMMON / ANGLES / COSTHE,PHI,COSDE1,PHI1,COSDE2,PHI2
      save  / WEKING /,/ MATPAR /
      save  / SSTHE /,/ ANGLES /
      dimension amdet(4)
      dimension bq1(4),bq2(4),bp1(4),bp2(4),bp3(4),bp4(4)
      common /nevik/ nevtru,ifprint
      save nevik
      SAVE
!!!
!     itype=1 WW kinematics with appropriate breit wigners to be set,
!     itype=2    kinematics with flatened breit wigners to be set, obsolete
!     itype=3    kinematics with appropriate breit wigners to be set, ini pairs
!     itype=4-6  kinematics with approp. b-wigners to set, t-chan. Obsolete?
! 
!
!#############################################################
!    GENERAL INITIALIZATION:                                 #
!    SETTING PRESAMPLER PARAMETERS AND MASSES IN ORDER       #
!    FOR PARTICULAR >ITYPE< SLOT-SPACE                       #
!    most of ITYPES differ by order of 4-vectors only        #
!#############################################################
       amdet(1)=amd1
       amdet(2)=amd2
       amdet(3)=amd3
       amdet(4)=amd4


      IF (MODE.EQ.1) THEN 
!##############################################
! INITIALIZATION FOR RECALCULATION MODE:      #
!  ANGLES AND S-i's FROM FOUR VECTORS         #
!##############################################
      if     (itype.le.3 )then
          call invkin(ctn,fin,ct1n,fi1n,ct2n,fi2n,
     $                  amwmn,amwpn,  bp1,bp2,bp3,bp4)
      elseif (itype.le.6 )then
        call invkin(ctn,fin,ct1n,fi1n,ct2n,fi2n,
     $                  amwmn,amwpn,  bp1,bp2,bp3,bp4)
      endif
!
      s1=amwmn**2
      s2=amwpn**2
      ENDIF

!##############################################
! BASIC PART:                                 #
! MODE=0 GENERATION AND JACOBIAN CALCULATION  #
! MODE=1 JACOBIAN CALCULATION ONLY            #
!##############################################
!... s1,s2 subspace
      if (itype.eq.1) then
       CALL RES2GN(mode,SVAR,SPRIM,AMx,GAMx,amdet,S1,S2,SSCRU)
      else
       CALL RES3GN(mode,itype,SVAR,SPRIM,AMx,GAMx,amdet,S1,S2,SSCRU)
      endif
      if (ifprint.eq.1) then
      write(*,*) 'invariants old-t ',s1,s2,sscru
      endif
      if (mode.eq.10.and.itype.eq.3) then
        write(*,*) 'itype=',itype
        write(*,*) 'invariants old-t ',s1,s2,sscru
      endif 
!
! rejection
      if(mode.eq.0.and.sscru.eq.0d0)  then
!-- short-out ... 
         fakir=0D0
         return
      endif

! lambda factors, can be moved to res2/3-s or even out.
      x1=s1/sprim
      x2=s2/sprim
      bmain=sqrt( (1-x1-x2)**2 - 4*x1*x2 )
      xwm1=amdet(1)**2/s1
      xwm2=amdet(2)**2/s1
      bwm=sqrt( (1-xwm1-xwm2)**2 - 4*xwm1*xwm2 )
      xwp1=amdet(3)**2/s2
      xwp2=amdet(4)**2/s2
      bwp=sqrt( (1-xwp1-xwp2)**2 - 4*xwp1*xwp2 )
      wjac=bmain*bwp*bwm

!... production angles
      if (itype.eq.1) then
       CALL cospro(mode,sprim,s1,s2,ctn,fin,xccos)
      else
       CALL cosprozz(mode,sprim,s1,s2,ctn,fin,xccos)
      endif
      if (ifprint.eq.1) then
      write(*,*) 'prod',ctn,xccos
      endif

! decay angles
      if (itype.le.3 )then
       ifl=1
       if (itype.eq.3 ) ifl=0
       CALL cosdecc(mode,ifl,sprim,ct1n,fi1n,xccos1)
       CALL cosdecc(mode,ifl,sprim,ct2n,fi2n,xccos2)

      else
       if (s1.gt.s2) then
        ifak=1
        if (ctn.lt.0d0) ifak=-1

        CALL cosdec_t(mode, 1,svar,sprim,s1,s2,ctn,fin,amel,
     @              amdet(1),amdet(2),ct1n,fi1n,xccos1)
        CALL cosdecc(mode,0,sprim,ct2n,fi2n,xccos2)
       else
 2        ifak=1
        if (ctn.lt.0d0) ifak=-1
        CALL cosdecc(mode,ifak,sprim,ct1n,fi1n,xccos1)
        CALL cosdec_t(mode,-1,svar,sprim,s2,s1,ctn,fin,amel,
     @              amdet(3),amdet(4),ct2n,fi2n,xccos2)
       endif
      endif
      if (ifprint.eq.1) then
      write(*,*) 'dec1 ',ct1n,xccos1
      write(*,*) 'dec2 ',ct2n,xccos2
      endif

!... WE CALCULATE OVERALL JACOBIAN ...
      fak= 1D0/32D0*xccos1*xccos2*xccos*sscru*wjac
!...  EN_pi=(2*pi)**4/(2*(2*PI)**3)**(r;r=4) 
      ENPI=(2*PI)**4/(2*(2*PI)**3)**4
      fakir=fak*ENPI
      if (ifprint.eq.1) then
      write(*,*) 'fakir ',fakir
      endif



      if (mode.eq.0) then 
!##############################################
!  KONSTRUCT FINAL 4-VECTORS etc:             #
!  MODE=0 ONLY                                #
!##############################################
!
      if(itype.le.3) then
       CALL kineww(svar,sprim,ctn,fin,ct1n,fi1n,ct2n,fi2n,
     $           sqrt(s1),sqrt(s2),amdet,bq1,bq2,bp1,bp2,bp3,bp4)
!
      elseif(itype.le.6) then
       CALL kineww(svar,sprim,ctn,fin,ct1n,fi1n,ct2n,fi2n,
     $           sqrt(s1),sqrt(s2),amdet,bq1,bq2,bp1,bp2,bp3,bp4)
      else
       write(6,*) 'spacegen: wrong itype=',itype
       stop
      endif        
      endif   

! security check
      if (fak.eq.0d0) then
       write(*,*) 'spacegen: we have troubles; fakir=',
     $  xccos1,xccos2,xccos,sscru,wjac
       write(*,*) 'please contact Z.Was '
       write(*,*) 'this effect is irrelevant or serious ...'
       write(*,*) 'spacegen: itype=',itype,' mode=',mode
       write(*,*) 'division by zero will be protected'
       write(*,*) 'bp1=',bp1
       write(*,*) 'bp2=',bp2
       write(*,*) 'bp3=',bp3
       write(*,*) 'bp4=',bp4
       write(*,*) amdet
       write(*,*) sqrt(s1),sqrt(s2)
!... WE Re-CALCULATE OVERALL JACOBIAN ...
!... this event was outside phase space, the only justifiable config.
!... is if s1 or s2 is just under threshold defined by electron and neutrino
!... masses
      sscru=1d-40
      fak= 1D0/32D0*xccos1*xccos2*xccos*sscru*wjac
!...  EN_pi=(2*pi)**4/(2*(2*PI)**3)**(r;r=4) 
      ENPI=(2*PI)**4/(2*(2*PI)**3)**4
      fakir=fak*ENPI
      endif

      end

      subroutine invkin(ctn,fin,ct1n,fi1n,ct2n,fi2n,
     $                  amwmn,amwpn,  bp1,bp2,bp3,bp4)
*     **********************************************************
c This routine calculates inverse kinematics for W-W+ pair production
c and decay 
c OUTPUT:
c         ctn,fin - W-  production angles 
c         ct1n,fi1n - W- decay products angles
c         ct2n,fi2n - W+ decay products angles
c         amwm, amwp - masses of W- and W+ resonances
c INPUT (to be taken from bormom!):
c         bp1(4), bp2(4) - four-momenta of W- decay products
c         bp3(4), bp4(4) - four-momenta of W+ decay products
c
c Written by: Wieslaw Placzek            date: 22.07.1994
c Rewritten by: M. Skrzypek              date: 3/15/95
c Last update: 9/5/96                    by: Z.W.
c
      implicit real*8 (a-h,o-z)
      common / matpar / pi,ceuler     
c.. four momenta in CMS' (effective e- beam along z+, exclusively for WWBORN)
      save   / matpar /
      save
      real*8 bq1(4),bq2(4),aa(4)
      dimension bp1(4),bp2(4),bp3(4),bp4(4)

      do i=1,4
           aa(i)= bp1(i)+bp2(i)
          bq1(i)= bp1(i)+bp2(i)
      enddo
        amwmn=sqrt(dmas2(aa))
      do i=1,4
           aa(i)= bp3(i)+bp4(i)
          bq2(i)= bp3(i)+bp4(i)
      enddo
        amwpn=sqrt(dmas2(aa))
cc ms      qq=dsqrt( (bq1(4)-amwmn)*(bq1(4)+amwmn) )      
      qq=dsqrt(bq1(1)**2+bq1(2)**2+bq1(3)**2)
      qqt=dsqrt(bq1(1)**2+bq1(2)**2)
cc ms
      ctn=bq1(3)/qq
      stn=sqrt(1d0-ctn**2)
cc ms      cfi=bq1(1)/stn/qq
cc ms      sfi=bq1(2)/stn/qq
      IF (QQT.GT.0D0) THEN                                             !cav
        cfi=bq1(1)/qqt
        sfi=bq1(2)/qqt
      ELSE                                                             !cav
        CFI=1D0                                                        !cav
        SFI=0D0                                                        !cav
!        WRITE (6,*)                                                    !cav
!     &    '+++ INVKIN +++ Warning: ThetaW=0. Phi undefined, set=0.'    !cav
      ENDIF                                                            !cav
cc ms
      fin=acos(cfi)
      if(sfi.le.0d0) fin=2*pi-fin
!
      call boostv(1,bq1,bp1,aa)
      qq=sqrt(aa(1)**2+aa(2)**2+aa(3)**2)
      ct1n=aa(3)/qq
cc ms      stn=sqrt(1d0-ct1n**2)
cc ms      cfi=aa(1)/stn/qq
cc ms      sfi=aa(2)/stn/qq
      qqt=sqrt(aa(1)**2+aa(2)**2)
      IF (QQT.GT.0D0) THEN                                             !cav
        cfi=aa(1)/qqt
        sfi=aa(2)/qqt
      ELSE                                                             !cav
        CFI=1D0                                                        !cav
        SFI=0D0                                                        !cav
!        WRITE (6,*)                                                    !cav
!     &    '+++ INVKIN +++ Warning: ThetaW1=0. Phi undefined, set=0.'   !cav
      ENDIF                                                            !cav
cc ms
      fi1n=acos(cfi)
      if(sfi.le.0d0) fi1n=2*pi-fi1n
!
      call boostv(1,bq2,bp3,aa)
      qq=sqrt(aa(1)**2+aa(2)**2+aa(3)**2)
      ct2n=aa(3)/qq
cc ms      stn=sqrt(1d0-ct2n**2)
cc ms      cfi=aa(1)/stn/qq
cc ms      sfi=aa(2)/stn/qq
      qqt=sqrt(aa(1)**2+aa(2)**2)
      IF (QQT.GT.0D0) THEN                                             !cav
        cfi=aa(1)/qqt
        sfi=aa(2)/qqt
      ELSE                                                             !cav
        CFI=1D0                                                        !cav
        SFI=0D0                                                        !cav
!        WRITE (6,*)                                                    !cav
!     &    '+++ INVKIN +++ Warning: ThetaW2=0. Phi undefined, set=0.'   !cav
      ENDIF                                                            !cav

cc ms
      fi2n=acos(cfi)
      if(sfi.le.0d0) fi2n=2*pi-fi2n
! 
      end

      subroutine invkintt(ctn,fin,ct1n,fi1n,ct2n,fi2n,
     $                  amwmn,amwpn,  bp1,bp2,bp3,bp4)
*     **********************************************************
c This routine calculates inverse kinematics for W-W+ pair production
c and decay 
c OUTPUT:
c         ctn,fin - W-  production angles 
c         ct1n,fi1n - W- decay products angles
c         ct2n,fi2n - W+ decay products angles
c         amwm, amwp - masses of W- and W+ resonances
c INPUT (to be taken from bormom!):
c         bp1(4), bp2(4) - four-momenta of W- decay products
c         bp3(4), bp4(4) - four-momenta of W+ decay products
c
c Written by: Wieslaw Placzek            date: 22.07.1994
c Rewritten by: M. Skrzypek              date: 3/15/95
c Last update: 9/5/96                    by: Z.W.
c
      implicit real*8 (a-h,o-z)
      common / matpar / pi,ceuler     
c.. four momenta in CMS' (effective e- beam along z+, exclusively for WWBORN)
      save  / matpar / 
      save
      real*8 bq1(4),bq2(4),aa(4),bb(4),e1(4)
      dimension bp1(4),bp2(4),bp3(4),bp4(4)
      do i=1,4
           aa(i)= bp1(i)+bp2(i)
          bq1(i)= bp1(i)+bp2(i)
      enddo
        amwmn=sqrt(dmas2(aa))
      do i=1,4
           aa(i)= bp3(i)+bp4(i)
          bq2(i)= bp3(i)+bp4(i)
      enddo
        amwpn=sqrt(dmas2(aa))
      do i=1,4
           bb(i)= bp1(i)+bp2(i)+bp3(i)+bp4(i)
      enddo
        s=(dmas2(bb))
cc ms      qq=dsqrt( (bq1(4)-amwmn)*(bq1(4)+amwmn) )      
      qq=dsqrt(bq1(1)**2+bq1(2)**2+bq1(3)**2)
      qqt=dsqrt(bq1(1)**2+bq1(2)**2)
cc ms
      ctn=bq1(3)/qq
      stn=sqrt(1d0-ctn**2)
cc ms      cfi=bq1(1)/stn/qq
cc ms      sfi=bq1(2)/stn/qq
      IF (QQT.GT.0D0) THEN                                             !cav
        cfi=bq1(1)/qqt
        sfi=bq1(2)/qqt
      ELSE                                                             !cav
        CFI=1D0                                                        !cav
        SFI=0D0                                                        !cav
!        WRITE (6,*)                                                    !cav
!     &    '+++ INVKINTT +++ Warning: ThetaW=0. Phi undefined, set=0.'  !cav
      ENDIF                                                            !cav

cc ms
      fin=acos(cfi)
      if(sfi.le.0d0) fin=2*pi-fin
!
      e1(4)=dsqrt(s/4d0)
      e1(3)=dsqrt(s/4d0)
      e1(2)=0d0
      e1(1)=0d0
      call boostv(1,bq1,bp1,aa)
      call boostv(1,bq1,e1,e1)
      call rotatv(-1,e1,aa,aa)
      qq=sqrt(aa(1)**2+aa(2)**2+aa(3)**2)
      ct1n=aa(3)/qq
cc ms      stn=sqrt(1d0-ct1n**2)
cc ms      cfi=aa(1)/stn/qq
cc ms      sfi=aa(2)/stn/qq
      qqt=sqrt(aa(1)**2+aa(2)**2)
      IF (QQT.GT.0D0) THEN                                             !cav
        cfi=aa(1)/qqt
        sfi=aa(2)/qqt
      ELSE                                                             !cav
        CFI=1D0                                                        !cav
        SFI=0D0                                                        !cav
!        WRITE (6,*)                                                    !cav
!     &    '+++ INVKINTT +++ Warning: ThetaW1=0. Phi undefined, set=0.' !cav
      ENDIF                                                            !cav
cc ms
      fi1n=acos(cfi)
      if(sfi.le.0d0) fi1n=2*pi-fi1n
! dotad ok
!
!
      e1(4)=dsqrt(s/4d0)
      e1(3)=-dsqrt(s/4d0)
      e1(2)=0d0
      e1(1)=0d0
      call boostv(1,bq2,bp4,aa)
      call boostv(1,bq2,e1,e1)
      aa(3)=-aa(3)
      call rotatv(-1,e1,aa,aa)
      qq=sqrt(aa(1)**2+aa(2)**2+aa(3)**2)
      ct2n=aa(3)/qq
cc ms      stn=sqrt(1d0-ct2n**2)
cc ms      cfi=aa(1)/stn/qq
cc ms      sfi=aa(2)/stn/qq
      qqt=sqrt(aa(1)**2+aa(2)**2)
      IF (QQT.GT.0D0) THEN                                             !cav
        cfi=aa(1)/qqt
        sfi=aa(2)/qqt
      ELSE                                                             !cav
        CFI=1D0                                                        !cav
        SFI=0D0                                                        !cav
!        WRITE (6,*)                                                    !cav
!     &    '+++ INVKINTT +++ Warning: ThetaW2=0. Phi undefined, set=0.' !cav
      ENDIF                                                            !cav

cc ms
      fi2n=acos(cfi)
      if(sfi.le.0d0) fi2n=2*pi-fi2n
! 
      end

      subroutine kineww(s,sprim,ct,fi,ct1,fi1,ct2,fi2,
     $            amwm,amwp,amdec,  q1,q2,p1,p2,p3,p4)
*     **********************************************************
c This routine calculates kinematics for W-W+ pair production
c and decay in e+e- collision in the CMS with z-axis pointing 
c in the e- direction.
c fixes also the 'effective beams', qeff1,qeff2
c INPUT:  s    - beams energy squared (in GeV**2)
c         sprim - actual center mass energy squared (in GeV**2)
c         cthe,fi - W-  production angles 
c         cdec1,fi1 - W- decay products angles
c         cdec2,fi2 - W+ decay products angles
c         amwm, amwp - masses of W- and W+ resonances
c         amdec(4) - decay products masses
c OUTPUT:
c         qeff1(4)      -effective (massless) e- beam in /MOMSET/
c         qeff2(4)      -effective (massless) e+ beam in /MOMSET/
c         q1(4)        - four-momentum of W-  
c         q2(4)        - four-momentum of W+
c         p1(4), p2(4) - four-momenta of W- decay products
c         p3(4), p4(4) - four-momenta of W+ decay products
c
c Written by: Wieslaw Placzek            date: 22.07.1994
c Rewritten by: M. Skrzypek              date: 3/15/95
c Last update: 4/1/95                by: M.S.
c
      implicit real*8 (a-h,o-z)
      common / matpar / pi,ceuler     
      common / momset / qeff1(4),qeff2(4),sphum(4),sphot(100,4),nphot  
      save   / matpar /,/ momset /
      save
      real*8 qsu(4),ef1(4),ef2(4),photd(4),sphotd(100,4)
      dimension amdec(4),  q1(4),q2(4),p1(4),p2(4),p3(4),p4(4)
!
c to activate dumps KINDMP=1
      KINDMP=0

      do i=1,4
        q1(i)=0d0      
        q2(i)=0d0      
        p1(i)=0d0      
        p2(i)=0d0      
        p3(i)=0d0      
        p4(i)=0d0      
        ef1(i)=0d0      
        ef2(i)=0d0      
      enddo
      ecm=sqrt(sprim)
      amwm2=amwm**2
      amwp2=amwp**2
      s1=amwm2
      s2=amwp2
      amp1s=amdec(1)**2
      amp2s=amdec(2)**2
      amp3s=amdec(3)**2
      amp4s=amdec(4)**2
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*) AMDEC(1),AMDEC(2),AMDEC(3),AMDEC(4)
        WRITE(6,*) AMP1S,AMP2S,AMP3S,AMP4S
        WRITE(6,*)'S,SPRIM,S1,S2',S,SPRIM,S1,S2
        WRITE(6,*)'DECAY COS1,2',CT1,CT2
      ENDIF
      st =sqrt(max(0D0,((1d0-ct )*(1d0+ct ))))
c..
      st1=sqrt(max(0D0,((1d0-ct1)*(1d0+ct1))))
      st2=sqrt(max(0D0,((1d0-ct2)*(1d0+ct2))))
c..
!... Momentum q1 of the first resonance
      q1(4)=(sprim+amwm2-amwp2)/(2d0*ecm)
!      qq=dsqrt( (q1(4)-amwm)*(q1(4)+amwm) )
      qq=dsqrt( (sprim-amwm2-amwp2)**2 -4*amwm2*amwp2 )/(2*ecm)
      q1(1)=qq*st*cos(fi)
      q1(2)=qq*st*sin(fi)
      q1(3)=qq*ct
      q1(4)=dsqrt(amwm2+q1(1)**2+q1(2)**2+q1(3)**2)
!... Momentum p1 in the rest frame of the first resonance
      ppene=(s1+amp1s-amp2s)/(2d0*amwm)
!      ppe=dsqrt( (ppene-amdec(1))*(ppene+amdec(1)) )
      ppe=dsqrt( (s1-amp1s-amp2s)**2 -4*amp1s*amp2s )/(2d0*amwm)
      p1(1)=ppe*st1*cos(fi1)
      p1(2)=ppe*st1*sin(fi1)
      p1(3)=ppe*ct1
c      p1(4)=ppene
      p1(4)=dsqrt(amdec(1)**2+p1(1)**2+p1(2)**2+p1(3)**2)
c...
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'Q1,P1 '
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,nphot)
      ENDIF
!... Boost to CMS-WW frame
      call boostv(-1,q1,p1,p1)
!... Momentum p2 of the second product of first resonance decay
      do 10 k=1,4
 10   p2(k)=q1(k)-p1(k)
c.. fine tuning on masses
      p1(4)=dsqrt(amdec(1)**2+p1(1)**2+p1(2)**2+p1(3)**2)
      p2(4)=dsqrt(amdec(2)**2+p2(1)**2+p2(2)**2+p2(3)**2)
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'Q1,P1,P2 '
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,nphot)
      ENDIF
!... Momentum q2 of the second resonance
!ms      q2(4)=ecm-q1(4)
      do 20 k=1,3
 20   q2(k)=-q1(k)
      q2(4)=dsqrt(amwp2+q2(1)**2+q2(2)**2+q2(3)**2)
!... Momentum p3 in the rest frame of the second resonance
      ppene=(s2+amp3s-amp4s)/(2d0*amwp)
!      ppe=dsqrt( (ppene-amdec(3))*(ppene+amdec(3)) )
      ppe=dsqrt( (s2-amp3s-amp4s)**2 -4*amp3s*amp4s )/(2d0*amwp)
      p3(1)=ppe*st2*cos(fi2)
      p3(2)=ppe*st2*sin(fi2)
      p3(3)=ppe*ct2
c      p3(4)=ppene
      p3(4)=dsqrt(amdec(3)**2+p3(1)**2+p3(2)**2+p3(3)**2)
c...
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'Q1,P1,P2,Q2,P3 '
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,nphot)
      ENDIF
!... Boost to CMS-WW frame
      call boostv(-1,q2,p3,p3)
!... Momentum p2 of the second product of first resonance decay
      do 30 k=1,4
 30   p4(k)=q2(k)-p3(k)
c.. fine tuning on masses
      p4(4)=dsqrt(amdec(4)**2+p4(1)**2+p4(2)**2+p4(3)**2)
      p3(4)=dsqrt(amdec(3)**2+p3(1)**2+p3(2)**2+p3(3)**2)
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'Q1,P1,P2,Q2,P3,P4, WW frame '
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,nphot)
      ENDIF
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'LAB NO PHOTS'
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,nphot)
      ENDIF

      end

      subroutine kinett(s,sprim,ct,fi,ct1,fi1,ct2,fi2,
     $                  amwm,amwp,amdec,  q1,q2,p1,p2,p3,p4)
*     **********************************************************
c This routine calculates kinematics for W-W+ pair production
c and decay in e+e- collision in the CMS with z-axis pointing 
c in the e- direction.
c fixes also the 'effective beams', qeff1,qeff2
c INPUT:  s    - beams energy squared (in GeV**2)
c         sprim - actual center mass energy squared (in GeV**2)
c         cthe,fi - W-  production angles 
c         cdec1,fi1 - W- decay products angles
c         cdec2,fi2 - W+ decay products angles
c         amwm, amwp - masses of W- and W+ resonances
c         amdec(4) - decay products masses
c OUTPUT:
c         qeff1(4)      -effective (massless) e- beam in /MOMSET/
c         qeff2(4)      -effective (massless) e+ beam in /MOMSET/
c         q1(4)        - four-momentum of W-  
c         q2(4)        - four-momentum of W+
c         p1(4), p2(4) - four-momenta of W- decay products
c         p3(4), p4(4) - four-momenta of W+ decay products
c
c Written by: Wieslaw Placzek            date: 22.07.1994
c Rewritten by: M. Skrzypek              date: 3/15/95
c Last update: 4/1/95                by: M.S.
c
      implicit real*8 (a-h,o-z)
      common / matpar / pi,ceuler     
      common / momset / qeff1(4),qeff2(4),sphum(4),sphot(100,4),nphot  
      save   / matpar /,/ momset /
      save
      real*8 qsu(4),ef1(4),ef2(4),photd(4),sphotd(100,4)
      dimension amdec(4), q1(4),q2(4),p1(4),p2(4),p3(4),p4(4)
      dimension e1(4),e2(4)   !! t-channel stuff
!
c to activate dumps KINDMP=1
      KINDMP=0
c to activate t-channel KINTCH=1
      KINTCH=1

      do i=1,4
        q1(i)=0d0      
        q2(i)=0d0      
        p1(i)=0d0      
        p2(i)=0d0      
        p3(i)=0d0      
        p4(i)=0d0      
        ef1(i)=0d0      
        ef2(i)=0d0      
      enddo

      ecm=sqrt(sprim)
      amwm2=amwm**2
      amwp2=amwp**2
      s1=amwm2
      s2=amwp2
      amp1s=amdec(1)**2
      amp2s=amdec(2)**2
      amp3s=amdec(3)**2
      amp4s=amdec(4)**2
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*) AMDEC(1),AMDEC(2),AMDEC(3),AMDEC(4)
        WRITE(6,*) AMP1S,AMP2S,AMP3S,AMP4S
        WRITE(6,*)'S,SPRIM,S1,S2',S,SPRIM,S1,S2
        WRITE(6,*)'DECAY COS1,2',CT1,CT2
      ENDIF
      st =sqrt(max(0D0,((1d0-ct )*(1d0+ct ))))
c..
      st1=sqrt(max(0D0,((1d0-ct1)*(1d0+ct1))))
      st2=sqrt(max(0D0,((1d0-ct2)*(1d0+ct2))))
c..
!... Momentum q1 of the first resonance
      q1(4)=(sprim+amwm2-amwp2)/(2d0*ecm)
!      qq=dsqrt( (q1(4)-amwm)*(q1(4)+amwm) )
      qq=dsqrt( (sprim-amwm2-amwp2)**2 -4*amwm2*amwp2 )/(2*ecm)
      q1(1)=qq*st*cos(fi)
      q1(2)=qq*st*sin(fi)
      q1(3)=qq*ct
      q1(4)=dsqrt(amwm2+q1(1)**2+q1(2)**2+q1(3)**2)
!... Momentum p1 in the rest frame of the first resonance
      ppene=(s1+amp1s-amp2s)/(2d0*amwm)
!      ppe=dsqrt( (ppene-amdec(1))*(ppene+amdec(1)) )
      ppe=dsqrt( (s1-amp1s-amp2s)**2 -4*amp1s*amp2s )/(2d0*amwm)
      p1(1)=ppe*st1*cos(fi1)
      p1(2)=ppe*st1*sin(fi1)
      p1(3)=ppe*ct1
c      p1(4)=ppene
      p1(4)=dsqrt(amdec(1)**2+p1(1)**2+p1(2)**2+p1(3)**2)
      IF(KINTCH.EQ.1)THEN
!!!!!!! for cosdec_t !!!!!!!
!beam
      e1(4) =        dsqrt(s/4d0)
      e1(3) =        dsqrt(s/4d0)
      e1(2) =        0d0
      e1(1) =        0d0
!boost beam to W- rest fr.
      call boostv(1,q1,e1,e1)
!rotate p1 from frame parallel to ef1 to CMS-oriented
      call rotatv(1,e1,p1,p1)
!!!!!!! end for cosdec_t !!!!!!!
      ENDIF

c...
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'Q1,P1 '
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,nphot)
      ENDIF
!... Boost to CMS-WW frame
      call boostv(-1,q1,p1,p1)
!... Momentum p2 of the second product of first resonance decay
      do 10 k=1,4
 10   p2(k)=q1(k)-p1(k)
c.. fine tuning on masses
      p1(4)=dsqrt(amdec(1)**2+p1(1)**2+p1(2)**2+p1(3)**2)
      p2(4)=dsqrt(amdec(2)**2+p2(1)**2+p2(2)**2+p2(3)**2)
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'Q1,P1,P2 '
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,nphot)
      ENDIF
!... Momentum q2 of the second resonance
!ms      q2(4)=ecm-q1(4)
      do 20 k=1,3
 20   q2(k)=-q1(k)
      q2(4)=dsqrt(amwp2+q2(1)**2+q2(2)**2+q2(3)**2)
      IF(KINTCH.NE.1)THEN
!... Momentum p3 in the rest frame of the second resonance
      ppene=(s2+amp3s-amp4s)/(2d0*amwp)
!      ppe=dsqrt( (ppene-amdec(3))*(ppene+amdec(3)) )
      ppe=dsqrt( (s2-amp3s-amp4s)**2 -4*amp3s*amp4s )/(2d0*amwp)
      p3(1)=ppe*st2*cos(fi2)
      p3(2)=ppe*st2*sin(fi2)
      p3(3)=ppe*ct2
c      p3(4)=ppene
      p3(4)=dsqrt(amdec(3)**2+p3(1)**2+p3(2)**2+p3(3)**2)
c...
      ELSE
!!!!!!! for cosdec_t !!!!!!!
!... Momentum p4 in the rest frame of the second resonance
      ppene=(s2+amp4s-amp3s)/(2d0*amwp)
!      ppe=dsqrt( (ppene-amdec(4))*(ppene+amdec(4)) )
      ppe=dsqrt( (s2-amp3s-amp4s)**2 -4*amp3s*amp4s )/(2d0*amwp)
      p4(1)=ppe*st2*cos(fi2)
      p4(2)=ppe*st2*sin(fi2)
      p4(3)=ppe*ct2
c      p4(4)=ppene
      p4(4)=dsqrt(amdec(4)**2+p4(1)**2+p4(2)**2+p4(3)**2)
!beam
      e2(4) =        dsqrt(s/4d0)
      e2(3) =       -dsqrt(s/4d0)
      e2(2) =        0d0
      e2(1) =        0d0
!boost beam to W- rest fr.
      call boostv(1,q2,e2,e2)
!rotate p1 from frame parallel to ef1 to CMS-oriented
      call rotatv(1,e2,p4,p4)
      p4(1)=p4(1)
      p4(2)=p4(2)
      p4(3)=-p4(3)
!!!!!!! end for cosdec_t !!!!!!!
      ENDIF

      IF(KINDMP.EQ.1)THEN
        IF(KINTCH.NE.1) WRITE(6,*)'Q1,P1,P2,Q2,P3 '
        IF(KINTCH.EQ.1) WRITE(6,*)'Q1,P1,P2,Q2,P4 '
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,nphot)
      ENDIF
!... Boost to CMS-WW frame
        IF(KINTCH.NE.1) THEN
          call boostv(-1,q2,p3,p3)
        ELSE
          call boostv(-1,q2,p4,p4)
        ENDIF
!... Momentum p3 of the second product of second resonance decay
      do 30 k=1,4
        IF(KINTCH.NE.1) THEN
          p4(k)=q2(k)-p3(k)
        ELSE
          p3(k)=q2(k)-p4(k)
        ENDIF
 30     continue
c.. fine tuning on masses
      p4(4)=dsqrt(amdec(4)**2+p4(1)**2+p4(2)**2+p4(3)**2)
      p3(4)=dsqrt(amdec(3)**2+p3(1)**2+p3(2)**2+p3(3)**2)
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'Q1,P1,P2,Q2,P3,P4, WW frame '
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,nphot)
      ENDIF
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'LAB NO PHOTS'
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,nphot)
      ENDIF

      end

      SUBROUTINE res2gn(mode,svar,sprim,rmas,rgam,amdec,s1,s2,wt)
! #############################################
! LIBRARY of angular etc sub-generators start #
! #############################################

!     ***************************************************************
! Generation of ds_1ds_2 distribution within phase space boundaries
! using weighted (pre-sampled) events
!---------------------
! note:
! so far generation is within theta_crude and fine tuning is added at the
! end. For non-acceptable events weight is set to zero.
!---------------------
! breit-wigners pre-samplers in both s_1 and s_2 channels are set.
! total volume 'prnorm' ( S(s') defined in formula 31 of koralw 1.02 manual) 
! is calculated including additional W(s_1)*W(s_2) factor 
! (see koralw 1.02 manual). To obtain proper ds_1ds_2 distribution
! weight wt=prnorm/W(s_1)/W(s_2) must be included, and this will help later
! cancelling singularities of matrix element
! 
! note: both resonances have the same mass distribution function
!         svar    - max sprim
!         sprim   - actual s
!         rmas    - central value of a resonance mass distribution
!         rgam    - width of a resonance
! OUTPUT: s1, s2  - svar's of two resonances
!         wt      - weight
! for mode=1
! INPUT:  s1, s2  - no generation,  just calculation of weight. 
!
! Written by: M. Skrzypek            date: 2/16/95
! Last update: 5/5/96                  by: Z. Was
!
      IMPLICIT real*8 (a-h,o-z)
      COMMON / matpar / pi,ceuler     
      real*8 AMDEC(4)
      REAL*8 drvec(100)
      SAVE a,b,winf,wmi,wma,wsqr,wrec,prsqr,prrec
      SAVE uma,umi,uinf,usqr,urec
      SAVE
!
!        write(6,*)'resms2',rmas,rgam
      a=rmas**2
      b=rmas*rgam
! arctg
      winf = 1/b*atan((svar   -a)/b)
      wma  = 1/b*atan((sprim/4d0-a)/b)
      wmi  = 1/b*atan(        -a /b)
! logarithm
      uinf =1/2d0/a*dlog((svar   -a)**2 +b**2)
      uma  =1/2d0/a*dlog((sprim/4d0-a)**2 +b**2)
      umi  =1/2d0/a*dlog(                b**2)
! thetas
      thespr=1d0
      thesvr=1d0
      IF((sprim/4d0).lt.a) thespr=0d0
      IF( svar      .lt.a) thesvr=0d0
      ulo= thespr*uma +(1d0-thespr)*umi
! normalisations
      wsqr=wma-wmi 
      usqr=thespr*(uma-umi)
      prsqr=(wsqr+usqr)**2
      wrec=winf-wma 
      urec=thesvr*(uinf -ulo)
      prrec=(wsqr+usqr)*(wrec+urec)
      prnorm=prsqr+2*prrec
!
!     ====================
      if (mode.ne.1) then 
!     ====================
!
 10   call varran(drvec,5)
      r1=drvec(1)
      r2=drvec(2)
      r3=drvec(3)
      r4=drvec(4)
      r5=drvec(5)

      IF(r3.le.prsqr/prnorm) THEN
!     ..square

!     ....s1
        IF(r4.ge.usqr/(wsqr+usqr)) THEN
!       ..arctg
          w1=r1*(wma-wmi) +wmi
          s1=b*tan(b*w1) +a
        ELSE
!       ..log
          u1=r1*(uma-umi) +umi
          s1=dsqrt(exp(2*a*u1) -b**2)+a
        ENDIF
!     ....s2
        IF(r5.ge.usqr/(wsqr+usqr)) THEN
!       ..arctg
          w2=r2*(wma-wmi) +wmi
          s2=b*tan(b*w2) +a
        ELSE
!       ..log
          u2=r2*(uma-umi) +umi
          s2=dsqrt(exp(2*a*u2) -b**2)+a
        ENDIF

      ELSEIF(r3.le.(prsqr+prrec)/prnorm) THEN
!     ..rectangle 1

!     ....s1
        IF(r4.ge.usqr/(wsqr+usqr)) THEN
!       ..arctg
          w1=r1*(wma-wmi) +wmi
          s1=b*tan(b*w1) +a
        ELSE
!       ..log
          u1=r1*(uma-umi) +umi
          s1=dsqrt(exp(2*a*u1) -b**2)+a
        ENDIF
!     ....s2
        IF(r5.ge.urec/(wrec+urec)) THEN
!       ..arctg
          w2=r2*(winf-wma) +wma     
          s2=b*tan(b*w2) +a
        ELSE
!       ..log
          u2=r2*(uinf-ulo) +ulo
          s2=dsqrt(exp(2*a*u2) -b**2)+a
        ENDIF

      ELSE
!     ..rectangle 2
!         write(6,*)'rect 1'
!     ....s1
        IF(r4.ge.urec/(wrec+urec)) THEN
!       ..arctg
          w1=r1*(winf-wma) +wma     
          s1=b*tan(b*w1) +a
        ELSE
!       ..log
          u1=r1*(uinf-ulo) +ulo
          s1=dsqrt(exp(2*a*u1) -b**2)+a
        ENDIF
!     ....s2
        IF(r5.ge.usqr/(wsqr+usqr)) THEN
!       ..arctg
          w2=r2*(wma-wmi) +wmi
          s2=b*tan(b*w2) +a
        ELSE
!       ..log
          u2=r2*(uma-umi) +umi
          s2=dsqrt(exp(2*a*u2) -b**2)+a
        ENDIF

      ENDIF
!
!     =====
      endif
!     =====

!
! crude distrib. value is 1/W(s_1)*1/W(s_2) see manual for definition
      xcrud=1d0
      IF(s1.gt.a) xcrud=xcrud*a/s1
      IF(s2.gt.a) xcrud=xcrud*a/s2
      xcrud=xcrud
     $  *((s1-rmas**2)**2 +(rmas*rgam)**2)
     $  *((s2-rmas**2)**2 +(rmas*rgam)**2)
!
      wt=prnorm*xcrud
! thresholds
      IF(sqrt(s1)+sqrt(s2).gt.sqrt(sprim)) THEN
        wt=0d0
      ENDIF
!-- check thresholds on decays
      IF(amdec(1)+amdec(2).gt.sqrt(s1)) THEN
        wt=0D0
      ENDIF
      IF(amdec(3)+amdec(4).gt.sqrt(s2)) THEN
        wt=0D0
      ENDIF
      END

      SUBROUTINE res3gn(mode,itype,svar,sprim,rmas,rgam,amdec,s1,s2,wt)
!     ***************************************************************
! Generation of ds_1ds_2 distribution within phase space boundaries
! using weighted (pre-sampled) events
!---------------------
! note:
! so far generation is within theta_crude and fine tuning is added at the
! end. For non-acceptable events weight is set to zero.
!---------------------
! breit-wigners pre-samplers in both s_1 and s_2 channels are set.
! total volume 'prnorm' ( S(s') defined in formula 31 of koralw 1.02 manual) 
! is calculated including additional W(s_1)*W(s_2) factor 
! (see koralw 1.02 manual). To obtain proper ds_1ds_2 distribution
! weight wt=prnorm/W(s_1)/W(s_2) must be included, and this will help later
! cancelling singularities of matrix element
! 
! note: both resonances have the same mass distribution function
!         svar    - max sprim
!         sprim   - actual s
!         rmas    - central value of a resonance mass distribution
!         rgam    - width of a resonance
! OUTPUT: s1, s2  - svar's of two resonances
!         wt      - weight
! for mode=1
! INPUT:  s1, s2  - no generation,  just calculation of weight. 
!
! Written by: M. Skrzypek            date: 2/16/95
! Last update: 5/5/96                  by: Z. Was
!
      IMPLICIT real*8 (a-h,o-z)
      COMMON / matpar / pi,ceuler
! This common contains parameters of non-established particles such as higgs
! Which need to be used by pre-sampler (to be activated by dipswitch IHIG
      COMMON / WEKIN3 / AMHIG,GAMHIG,IHIG
      SAVE / matpar /,/ WEKIN3 /     
      real*8 AMDEC(4),amd(4)
      REAL*8 drvec(100)
      SAVE
      do k=1,4
       amd(k)=amdec(k)
       if (amd(k).lt.0.0005d0) amd(k)=0.000511d0
      enddo
      POLD=0.3
!      if (itype.eq.3) pold=.7
      proa=0.5
      if (itype.eq.5) proa=0.2d0
      if (itype.eq.6) proa=0.8d0
      ALP2=ATAN((sprim-rmas**2)/rmas/rgam)
      ALP1=ATAN(((amd(1)+amd(2))**2-rmas**2)/rmas/rgam)
      BLP2=ATAN((sprim-rmas**2)/rmas/rgam)
      BLP1=ATAN(((amd(3)+amd(4))**2-rmas**2)/rmas/rgam)
      IF (IHIG.EQ.1) THEN
       CLP2=ATAN((sprim-AMHIG**2)/AMHIG/GAMHIG)
       CLP1=ATAN(((amd(1)+amd(2))**2-AMHIG**2)/AMHIG/GAMHIG)
       DLP2=ATAN((sprim-AMHIG**2)/AMHIG/GAMHIG)
       DLP1=ATAN(((amd(3)+amd(4))**2-AMHIG**2)/AMHIG/GAMHIG)
       PROB1=1D0/3D0
       PROB2=2D0/3D0
       PROB3=2D0/3D0
       PROB4=1D0
      ELSE
       CLP2=ATAN((sprim-rmas**2)/rmas/rgam)
       CLP1=ATAN(((amd(1)+amd(2))**2-rmas**2)/rmas/rgam)
       DLP2=ATAN((sprim-rmas**2)/rmas/rgam)
       DLP1=ATAN(((amd(3)+amd(4))**2-rmas**2)/rmas/rgam)
       PROB1=1D0/2D0
       PROB2=1D0/2D0
       PROB3=1D0/2D0
       PROB4=1D0
      ENDIF
      biglog1=log(sprim/(amd(1)+amd(2))**2)
      biglog2=log(sprim/(amd(3)+amd(4))**2)
!
!     ====================
      if (mode.ne.1) then 
!     ====================
!
 10   call varran(drvec,7)
      r1=drvec(1)
      r2=drvec(2)
      r3=drvec(3)
      r4=drvec(4)
      r5=drvec(5)
      r6=drvec(6)
      r7=drvec(7)
      IF(r6.lt.POLD) THEN
!! ########################################
      if(r3.lt.PROB1) then      
        ALP=ALP1+R1*(ALP2-ALP1)
        s1=rmas**2+rmas*rgam*TAN(ALP)
      elseif(r3.lt.PROB2) then  
        CLP=CLP1+R1*(CLP2-CLP1)
        s1=AMHIG**2+AMHIG*GAMHIG*TAN(DLP)    
      elseif(r3.lt.PROB3) then      
        s1=(sprim-(amd(1)+amd(2))**2)*r1+(amd(1)+amd(2))**2 
      else
        s1=(amd(1)+amd(2))**2*exp(r1*biglog1)
      endif
      if(r4.lt.PROB1) then   
        ALP=BLP1+R2*(BLP2-BLP1)
        s2=rmas**2+rmas*rgam*TAN(ALP)
      elseif(r4.lt.PROB2) then  
        DLP=DLP1+R2*(DLP2-DLP1)
        s2=AMHIG**2+AMHIG*GAMHIG*TAN(DLP) 
      elseif(r4.lt.PROB3) then   
        s2=(sprim-(amd(3)+amd(4))**2)*r2+(amd(3)+amd(4))**2
      else
        s2=(amd(3)+amd(4))**2*exp(r2*biglog2)
      endif
      ELSE ! PNEW !!!
      if(r7.lt.proa) then
      xx=4*(amd(1)+amd(2))**2/sprim
      beta=sqrt(1d0-4*(amd(1)+amd(2))**2/sprim)
      xlog=-log((1+beta)**2/xx)
      xlog1=-log(16D0/xx)
        u=(log((1D0+beta)/4D0))**2 +xlog*xlog1*r1
        costhe=-1D0/beta*(4D0*EXP(-SQRT(u))-1)
        s1=(sprim-(amd(1)+amd(2))**2)*(1d0-costhe)/2
     $    +(amd(1)+amd(2))**2
!        write(*,*) s1
!        biglog1=log(sprim/(amd(1)+amd(2))**2)
!        s1=(amd(1)+amd(2))**2*exp(r1*biglog1)
        spri1=(sqrt(sprim)-sqrt(s1))**2
        biglo1=log(spri1/(amd(3)+amd(4))**2)
        if(r7.lt.proa/2) then
         s2=(amd(3)+amd(4))**2*exp(r2*biglo1)
         s2=spri1+(amd(3)+amd(4))**2-s2
        else
         s2=(spri1-(amd(3)+amd(4))**2)*r2+(amd(3)+amd(4))**2
        endif

      else
      xx=4*(amd(3)+amd(4))**2/sprim
      beta=sqrt(1d0-4*(amd(3)+amd(4))**2/sprim)
      xlog=-log((1+beta)**2/xx)
      xlog1=-log(16D0/xx)
        u=(log((1D0+beta)/4D0))**2 +xlog*xlog1*r1
        costhe=-1D0/beta*(4D0*EXP(-SQRT(u))-1)
        s2=(sprim-(amd(3)+amd(4))**2)*(1d0-costhe)/2
     $    +(amd(3)+amd(4))**2

!        biglog2=log(sprim/(amd(3)+amd(4))**2)
!        s2=(amd(3)+amd(4))**2*exp(r1*biglog2)
        spri2=(sqrt(sprim)-sqrt(s2))**2
        biglo2=log(spri2/(amd(1)+amd(2))**2)
        if(r7.gt.proa+(1-proa)/2) then
         s1=(amd(1)+amd(2))**2*exp(r2*biglo2)
         s1=spri2+(amd(1)+amd(2))**2-s1
        else
         s1=(spri2-(amd(1)+amd(2))**2)*r2+(amd(1)+amd(2))**2
        endif

      endif
      ENDIF
!     =====
      endif
!     =====
      ph1c=(sprim-(amdec(1)+amdec(2))**2)
      ph2c=(sprim-(amdec(3)+amdec(4))**2)
!
      PH1a=((s1-rmas**2)**2+(rmas*rgam)**2)/(rmas*rgam)
      PH1a=PH1a*(ALP2-ALP1)
      PH2a=((s2-rmas**2)**2+(rmas*rgam)**2)/(rmas*rgam)
      PH2a=PH2a*(BLP2-BLP1)
!
      IF (IHIG.EQ.1) THEN
       PH1b=((s1-AMHIG**2)**2+(AMHIG*GAMHIG)**2)/(AMHIG*GAMHIG)
       PH1b=PH1b*(CLP2-CLP1)
       PH2b=((s2-AMHIG**2)**2+(AMHIG*GAMHIG)**2)/(AMHIG*GAMHIG)
       PH2b=PH2b*(DLP2-DLP1)
      ELSE
       PH1b=((s1-rmas**2)**2+(rmas*rgam)**2)/(rmas*rgam)
       PH1b=PH1b*(CLP2-CLP1)
       PH2b=((s2-rmas**2)**2+(rmas*rgam)**2)/(rmas*rgam)
       PH2b=PH2b*(DLP2-DLP1)
      ENDIF
!      
      ph1d=s1*biglog1
      ph2d=s2*biglog2
!!!
      ph1=1/( PROB1       /ph1a+(PROB2-PROB1)/ph1b
     $      +(PROB3-PROB2)/ph1c+(PROB4-PROB3)/ph1d)
      ph2=1/( PROB1       /ph2a+(PROB2-PROB1)/ph2b
     $      +(PROB3-PROB2)/ph2c+(PROB4-PROB3)/ph2d)
!      ph1=3/(1d0/ph1a+1d0/ph1b+1d0/ph1c)
!      ph2=3/(1d0/ph2a+1d0/ph2b+1d0/ph2c)
      prn=ph1*ph2

!####################################################
       biglog1=log(sprim/(amd(1)+amd(2))**2)
       ph1cc=s1*biglog1                           ! s1 -->
c to jest zlosliwe swinstwo !! rozklad musi byc 1/E*ln(s1/E**2)
c co powoduje, ze rozbieznosc jest nieco `przydymiona'.
      xx=4*(amd(1)+amd(2))**2/sprim
      beta=sqrt(1d0-4*(amd(1)+amd(2))**2/sprim)
      xlog=-log((1+beta)**2/xx)
      xlog1=-log(16D0/xx)
      cost=1-2*(s1-(amd(1)+amd(2))**2)/(sprim-(amd(1)+amd(2))**2)
      xccos=1d0/2d0*beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-cost)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-cost))))
       ph1cc=(sprim-(amd(1)+amd(2))**2)/xccos/2
       spri1=(sqrt(sprim)-sqrt(s1))**2
       biglo1=log(spri1/(amd(3)+amd(4))**2)
       ph2cc=1/(0.5/((spri1+(amd(3)+amd(4))**2-s2)*biglo1)
     $         +0.5/(spri1-(amd(3)+amd(4))**2))           !    --> s2 

       biglog2=log(sprim/(amd(3)+amd(4))**2)
       ph1cd=s2*biglog2                           ! s2 --> 
      xx=4*(amd(3)+amd(4))**2/sprim
      beta=sqrt(1d0-4*(amd(3)+amd(4))**2/sprim)
      xlog=-log((1+beta)**2/xx)
      xlog1=-log(16D0/xx)
      cost=1-2*(s2-(amd(3)+amd(4))**2)/(sprim-(amd(3)+amd(4))**2)
      xccos=1d0/2d0*beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-cost)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-cost))))
       ph1cd=(sprim-(amd(3)+amd(4))**2)/xccos/2

       spri2=(sqrt(sprim)-sqrt(s2))**2
       biglo2=log(spri2/(amd(1)+amd(2))**2)
       ph2cd=1/(0.5/((spri2+(amd(1)+amd(2))**2-s1)*biglo2) 
     $         +0.5/(spri2-(amd(1)+amd(2))**2))           !    --> s1 

       prx=1d0/(proa/(ph1cc*ph2cc)+(1d0-proa)/(ph1cd*ph2cd))
      prnorm=1d0/(pold/prn+(1d0-pold)/prx)
      wt=prnorm
!####################################################
! thresholds
      IF(sqrt(s1)+sqrt(s2).gt.sqrt(sprim)) THEN
        wt=0d0
      ENDIF
!-- check thresholds on decays
      IF(amdec(1)+amdec(2).gt.sqrt(s1)) THEN
        wt=0D0
      ENDIF
      IF(amdec(3)+amdec(4).gt.sqrt(s2)) THEN
        wt=0D0
      ENDIF
      if(mode.eq.1.and.wt.eq.0d0) then
      write(*,*) 'RES3-mode=1 vol=',ph1,ph2
      write(*,*) sqrt(s1),'+',sqrt(s2),'.gt.',sqrt(sprim)
      write(*,*) amdec
      wt=prnorm
      endif
      END

      SUBROUTINE cospro(mode,s,s1,s2,costhe,phipro,wt)
*     ***************************************************
! Crude generation of costhe according to a simplified distribution.
! OUTPUT: costhe - cos(theta), theta - polar angle of W- in the CMS 
!         of the incoming beams (+z axis along e- direction)
!         xccos - value of the function
!                      (for mode=1 costhe becames input for xccos
!                                     - no generation)
c
! Written by: M. Skrzypek            date: 3/1/95
! Last update:                         by: 
c
      implicit real*8 (a-h,o-z)
      common / matpar / pi,ceuler     
      real*8 drvec(100)
      save
!
CC==>>

!ms      wlambd=s**2+s1**2+s2**2-2*s*s1-2*s*s2-2*s1*s2
      wlambd=max(0d0,(s-s1-s2)**2 -4*s1*s2)
!      write(6,*)s,s1,s2,wlambd
      aa=(s-s1-s2)/2d0
      bb=-dsqrt(wlambd)/2d0
      ymi=dlog(aa-bb)/bb
      yma=dlog(s1*s2/(aa-bb))/bb

!      z=.4d0/s*(aa-bb)*2/s
      z=0d0  ! auxilliary, supposed to be 0


! this was `dead code' 05.06.96 ZW:      wt=2*pi/xccos
!
      IF(mode.ne.1) then
      call varran(drvec,3)
      y=drvec(1)*(yma-ymi)+ymi
      costhe=(exp(bb*y)-aa)/bb
      IF( drvec(2).gt.(yma-ymi)/(z+yma-ymi) )  costhe=2*drvec(1)-1  !
c++      write(6,*)'tran cosgen',aa+bb*costhe
      phipro=2*pi*drvec(3)
      endif
!
      xccos=(1/((s1*s2/(aa-bb))+(bb*costhe-bb)) +z/2d0)/(yma-ymi+z) 
      wt=2*pi/xccos 
      end

      SUBROUTINE cosprozz(mode,s,s1,s2,costhe,phipro,wt)
*     ***************************************************
! Crude generation of costhe according to a simplified distribution.
! OUTPUT: costhe - cos(theta), theta - polar angle of W- in the CMS 
!         of the incoming beams (+z axis along e- direction)
!         xccos - value of the function
!                      (for mode=1 costhe becames input for xccos
!                                     - no generation)
c
! Written by: M. Skrzypek            date: 3/1/95
! Last update:                         by: 
c
      implicit real*8 (a-h,o-z)
      common / matpar / pi,ceuler 
      common /nevik/ nevtru,ifprint
      save nevik
   
      real*8 drvec(100)
      save
!
CC==>>

!ms      wlambd=s**2+s1**2+s2**2-2*s*s1-2*s*s2-2*s1*s2
      wlambd=max(0d0,(s-s1-s2)**2 -4*s1*s2)
!      write(6,*)s,s1,s2,wlambd
      aa=(s-s1-s2)/2d0
      bb=-dsqrt(wlambd)/2d0
      ymi=dlog(aa-bb)/bb
!      yma=dlog(aa+bb)/bb
      yma=dlog(s1*s2/(aa-bb))/bb
!      z=.4d0/s*(aa-bb)*2/s
      z=0d0  ! auxilliary, supposed to be 0
      IF(mode.eq.0) then

       call varran(drvec,3)

       y=drvec(1)*(yma-ymi)+ymi
       IF( drvec(2).lt.1d0/3d0) then
        costhe=(exp(bb*y)-aa)/bb
       elseIF( drvec(2).lt.2d0/3d0) then
        costhe=-(exp(bb*y)-aa)/bb
       else
        costhe=2*drvec(1)-1  !
       endif
       phipro=2*pi*drvec(3)
      endif
      xccos=1d0/3d0/((s1*s2/(aa-bb))+(bb*costhe-bb))/(yma-ymi)
     $     +1d0/3d0/((s1*s2/(aa-bb))-(bb*costhe+bb))/(yma-ymi)
     $     +1d0/6d0
c++      write(6,*)'tran cosgen',aa+bb*costhe
      wt=2*pi/xccos 
      if (ifprint.eq.1) then
      write(*,*) 'cosprozz',aa,bb,costhe
      write(*,*) ((s1*s2/(aa-bb))+(bb*costhe-bb))*(yma-ymi)
      write(*,*) (s1*s2/(aa-bb)-bb)*(yma-ymi),bb*(yma-ymi)
      write(*,*) ((s1*s2/(aa-bb))-(bb*costhe+bb))*(yma-ymi)
      endif

      end

      SUBROUTINE cosdecc(mode,iflag,svar,cdec,phi,wt)
*     ***************************************
! Crude generation of decay costhe according to a simplified distribution.
!   mode: 0-generation
!         1-xccos of given cdec
!   cdec:  value of generated cosine
!   xccos: value of distribution function
      implicit real*8 (a-h,o-z)
      common / matpar / pi,ceuler     
      common / wekin2 / amaw,gammw,gmu,alphaw   
! This common can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      real*8 drvec(100)
      save

      if (iflag.eq.0) then
       KeySpn = 0
      else
       KeySpn = MOD(KeyPhy,10000)/1000
      endif

      IF(keyspn.eq.1) THEN                        !1002=.78
        IF(svar.gt.500**2) THEN                    !502=.4
          delta=0.4d0+ (svar/500**2 -1)/8d0
        ELSEIF(svar.gt.4*amaw**2) THEN             !162=.4
          delta=.4d0
        ELSEIF(svar.gt.4*(amaw-5*gammw)**2) THEN   !142=.78
          delta=.4d0+ (1-svar/(4*amaw**2))*2d0
        ELSEIF(svar.gt.4*(amaw-10*gammw)**2) THEN  !122=40
          delta=.844d0+ (1-svar/(4*(amaw-5*gammw)**2))*100d0
        ELSE
          delta=40d0
        ENDIF

        IF(mode.eq.0)THEN
 11       call varran(drvec,3)
          cdec=2*drvec(1)-1
          xccos=(1+delta+cdec)/(1+delta)
          IF((2+delta)/(1+delta)*drvec(2).gt.xccos) goto 11
          phi =2*pi*drvec(3)
        ELSE
          xccos=(1+delta+cdec)/(1+delta)
        ENDIF
      ELSEIF(keyspn.eq.0) THEN
        IF(mode.eq.0)THEN
          call varran(drvec,3)
          cdec=2*drvec(1)-1
          phi =2*pi*drvec(3)
        ENDIF
        xccos=1D0
      ENDIF
      wt= 4*pi/xccos
      end

      SUBROUTINE cosdec_t(mode,ibeam,svar,sprim,s1,s2,ct,fi,ambeam,
     @                    amfi1,amfi2,   cosu,phi,wt)
*     ***************************************
! Crude generation of decay costhe according to a simplified distribution.
!   mode: 0-generation
!         1-xccos of given cdec
!   cdec:  value of generated cosine
!   xccos: value of distribution function
      implicit real*8 (a-h,o-z)
      common / matpar / pi,ceuler     
      common / wekin2 / amaw,gammw,gmu,alphaw   
! This common can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      common /nevik/ nevtru,ifprint
      save nevik

      real*8 drvec(100)
      save
C simplified version of this routine.
      if (mode.ne.0) costhe=cosu*ibeam
      xx=s2/svar
      beta=sqrt(1d0-s2/svar)
      xlog=log((1+beta)**2/xx)
      xlog=-log((1+beta)**2/xx)
      xlog1=-log(16D0/xx)
      IF(mode.eq.0) then
 5      continue
        call varran(drvec,3)
       IF( drvec(2).lt.1d0/4d0 ) then
        costhe=-1d0/beta*(xx/(1+beta)*exp(xlog*drvec(1))-1d0)
        u=(log((1D0+beta)/4D0))**2 +xlog*xlog1*drvec(1)
        costhe=-1D0/beta*(4D0*EXP(-SQRT(u))-1)
       elseIF( drvec(2).lt.1d0/2d0 ) then
        costhe=-1d0/beta*(xx/(1+beta)*exp(-xlog*drvec(1))-1d0)
!       elseIF( drvec(2).lt.3d0/4d0 ) then
!        costhe= 1d0/beta*(xx/(1+beta)*exp(-xlog*drvec(1))-1d0)
       else
        costhe=2*drvec(1)-1 !
       endif
       phi=2*pi*drvec(3)
      IF (COSTHE.eq.1d0.or.COSTHE.eq.-1D0) goto 5
      cosu=costhe*ibeam
      endif

      cost=min(1d0,costhe)
      if (ifprint.eq.1) then
       write(*,*) 'cosdec-t',xx,svar,costhe,cosu
      endif
      xccos=1d0/4d0+1d0/4d0/beta/(-xlog)*
     $      (1d0/(xx/(1d0+beta)+beta*(1D0-cost)))
!      xccos=xccos+1d0/3d0/beta/(-xlog)*
!     $      (1d0/(xx/(1d0+beta)+beta*(1D0+cost)))

      xccos=xccos+1d0/8d0*beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-cost)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-cost))))!!! +1d0/(1+beta*costhe))
! ms 17.06.96 here was wrong sign.
      wt= 4*pi/xccos/2
!
      end

      SUBROUTINE cosdec_xt(mode,ibeam,svar,sprim,s1,s2,ct,fi,ambeam,
     @                    amfi1,amfi2,   costhe,phi,wt)
*     ***************************************
! Crude generation of decay costhe according to a simplified distribution.
!   mode: 0-generation
!         1-xccos of given cdec
!   cdec:  value of generated cosine
!   xccos: value of distribution function
      implicit real*8 (a-h,o-z)
      common / matpar / pi,ceuler     
      common / wekin2 / amaw,gammw,gmu,alphaw   
! This common can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      real*8 drvec(100),q1(4),e1(4),e1p(4)
      save

      ecm=sqrt(sprim)
      amwm=dsqrt(s1)
      amwp=dsqrt(s2)
      amwm2=s1
      amwp2=s2
      st =sqrt((1-ct )*(1+ct ))

!... Momentum q1 of the first resonance
      q1(4)=(sprim+amwm2-amwp2)/(2d0*ecm)
!      qq=dsqrt( (q1(4)-amwm)*(q1(4)+amwm) )
      qq=dsqrt( (sprim-amwm2-amwp2)**2 -4*amwm2*amwp2 )/(2*ecm)
      q1(1)=-ibeam*qq*st*cos(fi)
      q1(2)=-ibeam*qq*st*sin(fi)
      q1(3)=-ibeam*qq*ct
      q1(4)=dsqrt(amwm2+q1(1)**2+q1(2)**2+q1(3)**2)

!beam
      e1(4) =        dsqrt(svar/4d0)
      e1(3) = -ibeam*dsqrt(svar/4d0 -ambeam**2)
      e1(2) =        0d0
      e1(1) =        0d0
!transform beam to W rest fr.
!      call boostv(1,q1,q1,e1p)
!      write(6,*)'cosdec_t=>',e1
!      write(6,*)'        =>',e1p,amwm
!      call rotatv(-1,q1,q1,e1p)
!      write(6,*)'        =>',e1p
      call boostv(1,q1,e1,e1p)
!first fermion
      x0 = 1/2d0/amwm*(amwm2-amfi2**2+amfi1**2)
      xx = dsqrt(x0**2 -amfi1**2)
      ee = dsqrt(e1p(4)**2 -ambeam**2)


      aa = x0*e1p(4)   !-(ambeam**2+amfi1**2)/2d0
      bb = -xx*ee
cc      write(6,*)'aa,bb',aa,bb,aa+bb
cc      write(6,*)'x0,e1p(4),xx,ee',x0,e1p(4),xx,ee

      cosmax =   1-2d-8
      cosmin = -(1-2d-8)

      ymi=dlog(aa+cosmin*bb)/bb
      yma=dlog(aa+cosmax*bb)/bb
cc      tmin=11d0
cc      yma=dlog(tmin)/bb

      z=.4d0/svar*(aa-bb)*2/svar
      z=.1d0*(aa-bb)/svar
      z=.5d0*(aa-bb)**2/svar**2
      z=.02d0
      z=.004d0*svar/(aa-bb)          !! best of all (180gev) !!
!!      write(6,*)'zety ',(aa-bb)/svar,(aa-bb)**2/svar,(aa-bb)**2/svar**2
!      z=0d0  ! auxilliary, supposed to be 0

      IF(mode.eq.0) then

       call varran(drvec,3)

       y=drvec(1)*(yma-ymi)+ymi
       costhe=(exp(bb*y)-aa)/bb
       IF( drvec(2).gt.(yma-ymi)/(z+yma-ymi) )  costhe=2*drvec(1)-1 !
       phi=2*pi*drvec(3)
      endif
      xccos=2*(1/(aa+bb*costhe) +z/(cosmax-cosmin))/(yma-ymi+z) 
      wt= 4*pi/xccos
!
cc      write(6,*)'tran cosgen',aa+bb*costhe,costhe,xccos,xcc/xccos
cc      write(6,*)'tran yma,ymi',yma,ymi,yma-ymi

      end

      FUNCTION dd2(x,y)
!     *********************************
      implicit double precision (a-h,o-z) 
      dimension x(4),y(4)   
      dd2 = (x(4)+y(4))**2 -(x(3)+y(3))**2 -(x(2)+y(2))**2
     %     -(x(1)+y(1))**2 
      end

      subroutine boostv(idir,vv,pp,q)
*     *******************************
c Boost along arbitrary vector v (see eg. J.D. Jacson, "Classical 
c Electrodynamics).
c Four-vector pp is boosted from an actual frame to the rest frame 
c of the four-vector v (for idir=1) or back (for idir=-1). 
c q is a resulting four-vector.
c Note: v must be time-like, pp may be arbitrary.
c
c Written by: Wieslaw Placzek            date: 22.07.1994
c Last update: 3/29/95                     by: M.S.
c 
      implicit real*8 (a-h,o-z)
      parameter (nout=6)
      real*8 v(4),p(4),q(4),pp(4),vv(4)  
      save
!
      do 1 i=1,4
      v(i)=vv(i)
 1    p(i)=pp(i)
      amv=(v(4)**2-v(1)**2-v(2)**2-v(3)**2)
      if (amv.le.0d0) write(*,*) 'bosstv: warning amv**2=',amv
      amv=sqrt(abs(amv))
      if (idir.eq.-1) then
        q(4)=( p(1)*v(1)+p(2)*v(2)+p(3)*v(3)+p(4)*v(4))/amv
        wsp =(q(4)+p(4))/(v(4)+amv)
      elseif (idir.eq.1) then
        q(4)=(-p(1)*v(1)-p(2)*v(2)-p(3)*v(3)+p(4)*v(4))/amv
        wsp =-(q(4)+p(4))/(v(4)+amv)
      else
        write(nout,*)' >>> boostv: wrong value of idir = ',idir
      endif
      q(1)=p(1)+wsp*v(1)
      q(2)=p(2)+wsp*v(2)
      q(3)=p(3)+wsp*v(3)
      end
             
 
      subroutine rotatv(mode,qq,pp,r)        
c     *******************************        
c rotation along arbitrary axis.
c pp rotated into r  from actual frame to frame with z-axis along qq  
c NOT TRUE 7/8/96 ms: (mode = 1) or back (mode = -1).      
c     TRUE 7/8/96 ms: (mode = -1) or back (mode = 1).      
c Written by: M. Skrzypek           date: 04.1995
c Last update: 7/9/96               by: M.S.   
      implicit double precision (a-h,o-z) 
      dimension qq(4),pp(4),r(4),tt(4)   
      parameter (pi = 3.1415926535897932D0)
      save
      the= asin(qq(1)/sqrt(qq(1)**2+qq(2)**2+qq(3)**2))
      phi= asin(qq(2)/sqrt(qq(2)**2+qq(3)**2))   
! ms 7/8/96, following line was missing (plus definition of PI)
      if(qq(3).lt.0d0) phi=pi-phi
      if(mode.eq.-1)then
        call rxtod1(phi,pp,tt)
        call rxtod2(-the,tt,r)
      elseif(mode.eq. 1)then
        call rxtod2(the,pp,tt)
        call rxtod1(-phi,tt,r)
      else
        write(6,*)'rotatv==> wrong mode:',mode
      endif
      end
 
      FUNCTION ANGLE(P,Q)
*     ******************
*  ANGLE BETWEEN TWO 3-COMPONENTS OF FOUR-VECTORS
*     ******************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION P(4),Q(4)
      PQ=P(3)*Q(3)+P(2)*Q(2)+P(1)*Q(1)
      PP=P(3)*P(3)+P(2)*P(2)+P(1)*P(1)
      QQ=Q(3)*Q(3)+Q(2)*Q(2)+Q(1)*Q(1)
      ARG=PQ/SQRT(PP*QQ)
      IF(ARG.GT. 1D0) ARG= 1D0
      IF(ARG.LT.-1D0) ARG=-1D0
      ANGLE=ACOS(ARG)
      END

      function dmas2(p)
c     *******************
      implicit real*8 (a-h,o-z)
      real*8 p(4)
      d3m = dsqrt(p(3)**2 +p(2)**2 +p(1)**2)  
      dmas2= (p(4)-d3m)*(p(4)+d3m)
      end

      function dot(p,q)
c     *******************
      implicit real*8 (a-h,o-z)
      real*8 p(4),q(4)  
      dot= p(4)*q(4) -p(3)*q(3) -p(2)*q(2) -p(1)*q(1)
      end

      subroutine invx(s,sprim,ct,fi,ct1,fi1,ct2,fi2,
     $                  amwm,amwp,amdec,  q1,q2,p1,p2,p3,p4)
      implicit real*8 (a-h,o-z)
! ... this routine is for tests of invkin only. It is nat called at all
c.. four momenta in CMS' (effective e- beam along z+, exclusively for WWBORN)
      common / bormom / bq1(4),bq2(4),bp1(4),bp2(4),bp3(4),bp4(4)
      save   / bormom /
      dimension amdec(4),q1(4),q2(4),p1(4),p2(4),p3(4),p4(4)
      dimension rp1(4),rp2(4),rp3(4),rp4(4)
c to activate dumps KINDMP=1
      KINDMP=0

      IF(KINDMP.EQ.1) THEN
      write(*,*) '================================================='
      write(*,*) '============     begin     ======================'
      write(*,*) 'we want:  ct2=', ct2,'  fi2=', fi2
      write(*,*) 'we want:  ct1=', ct1,'  fi1=', fi1
      write(*,*) 'we want:   ct=',  ct,'   fi=', fi
      write(*,*) 'we want: amwm=',amwm,' amwp=',amwp
      write(*,*) '-------------------------------------------------'
      endif
!!!
      do k=1,4
      rp1(k)=bp1(k)
      rp2(k)=bp4(k)
      rp3(k)=bp3(k)
      rp4(k)=bp2(k)
      enddo
      call invkintt(ctn,fin,ct1n,fi1n,ct2n,fi2n,
     $                  amwmn,amwpn,  rp1,rp2,rp3,rp4)
!
      IF(KINDMP.EQ.1) THEN
      write(*,*) 'we  get:  ct2=', ct2n,'  fi2=', fi2n
      write(*,*) 'we  get:  ct1=', ct1n,'  fi1=', fi1n
      write(*,*) 'we  get:   ct=',  ctn,'   fi=', fin
      write(*,*) 'we  get: amwm=',amwmn,' amwp=',amwpn
      write(*,*) '============       end     ======================'
      write(*,*) '================================================='
      endif
      end
