      PARAMETER (LOUTGO =  2, LINCOM =  1)
      PARAMETER (LANTIP = -1, LPRTCL =  1)
      PARAMETER (LSCALR =  1)
      PARAMETER (LEPEXA =  2, LEPEXW =  3, LEPEXZ =  3, LEPEXG =  2)
      PARAMETER (LEPINA =  4, LEPINW =  4, LEPINZ =  4, LEPING =  3)
      PARAMETER (LEXTRN =  2, LINTRN =  4)
* Table of amplitudes
      PARAMETER (NGRAPH =   88, NEXTRN =   6, LAG =  64)
      PARAMETER (NGRPSQ = NGRAPH*NGRAPH)
      COMMON /A47_AMSLCT/JSELG(NGRAPH), JGRAPH, JHIGGS, JWEAKB
      COMPLEX*16 AG, APROP
      COMMON /A47_AMGRPH/AG(0:LAG-1,NGRAPH), APROP(NGRAPH),
     &               ANCP(NGRAPH), ANSP(0:NGRAPH),
     &               CF(NGRAPH,NGRAPH), IGRAPH(NGRAPH)

* Coupling constants
      COMMON /A47_AMCPLC/CZWW       ,CAWW       ,CWWAA      ,CWWZA      ,
     &               CWWZZ      ,CWWWW      ,CWL   (2,2),CWEL  (2,2),
     &               CWMU  (2,2),CWTA  (2,2),CWQ   (2,2),CWUQ  (2,2),
     &               CWCQ  (2,2),CWTQ  (2,2),CALD  (2)  ,CAEL  (2)  ,
     &               CAMU  (2)  ,CATA  (2)  ,CAQU  (2)  ,CAUQ  (2)  ,
     &               CACQ  (2)  ,CATQ  (2)  ,CAQD  (2)  ,CADQ  (2)  ,
     &               CASQ  (2)  ,CABQ  (2)  ,CZLD  (2)  ,CZEL  (2)  ,
     &               CZMU  (2)  ,CZTA  (2)  ,CZLU  (2)  ,CZNE  (2)  ,
     &               CZNM  (2)  ,CZNT  (2)  ,CZQU  (2)  ,CZUQ  (2)  ,
     &               CZCQ  (2)  ,CZTQ  (2)  ,CZQD  (2)  ,CZDQ  (2)  ,
     &               CZSQ  (2)  ,CZBQ  (2)  ,CWXP  (2)  ,CWX3  (2)  ,
     &               CZXX       ,CAXX       ,CZ3P       ,CPWW       ,
     &               CPZZ       ,CXWZ  (2)  ,CXWA  (2)  ,CPPWW      ,
     &               CPPZZ      ,CPXWZ (2)  ,CPXWA (2)  ,C33WW      ,
     &               C33ZZ      ,C3XWZ (2)  ,C3XWA (2)  ,CXXWW      
* Coupling constants
      COMMON /A47_AMCPLC/CXXZZ      ,CXXAA      ,CXXAZ      ,CPXX       ,
     &               CP33       ,CPPP       ,C3333      ,CPPPP      ,
     &               CXX33      ,CXXPP      ,CPP33      ,CXXXX      ,
     &               CXL   (2,2),CXEL  (2,2),CXMU  (2,2),CXTA  (2,2),
     &               CXQ   (2,2),CXUQ  (2,2),CXCQ  (2,2),CXTQ  (2,2),
     &               CPLD  (2)  ,CPEL  (2)  ,CPMU  (2)  ,CPTA  (2)  ,
     &               CPLU  (2)  ,CPQU  (2)  ,CPUQ  (2)  ,CPCQ  (2)  ,
     &               CPTQ  (2)  ,CPQD  (2)  ,CPDQ  (2)  ,CPSQ  (2)  ,
     &               CPBQ  (2)  ,C3LD  (2)  ,C3EL  (2)  ,C3MU  (2)  ,
     &               C3TA  (2)  ,C3QU  (2)  ,C3UQ  (2)  ,C3CQ  (2)  ,
     &               C3TQ  (2)  ,C3QD  (2)  ,C3DQ  (2)  ,C3SQ  (2)  ,
     &               C3BQ  (2)  ,CWCPZ      ,CWCMZ      ,CWCPA      ,
     &               CWCMA      ,CZCMM      ,CZCPP      ,CACMM      ,
     &               CACPP      ,CXCPZ      ,CXCPA      ,CXCMZ      ,
     &               CXCMA      ,C3CPP      ,C3CMM      ,CPCPP      
* Coupling constants
      COMMON /A47_AMCPLC/CPCMM      ,CPCZZ      ,CQCD       ,CQQG  (2)  ,
     &               CQCDSQ     
      COMPLEX*16     CZWW  ,   CAWW  ,   CWWAA ,   CWWZA ,   CWWZZ ,   
     &               CWWWW ,   CWL   ,   CWEL  ,   CWMU  ,   CWTA  ,   
     &               CWQ   ,   CWUQ  ,   CWCQ  ,   CWTQ  ,   CALD  ,   
     &               CAEL  ,   CAMU  ,   CATA  ,   CAQU  ,   CAUQ  ,   
     &               CACQ  ,   CATQ  ,   CAQD  ,   CADQ  ,   CASQ  ,   
     &               CABQ  ,   CZLD  ,   CZEL  ,   CZMU  ,   CZTA  ,   
     &               CZLU  ,   CZNE  ,   CZNM  ,   CZNT  ,   CZQU  ,   
     &               CZUQ  ,   CZCQ  ,   CZTQ  ,   CZQD  ,   CZDQ  ,   
     &               CZSQ  ,   CZBQ  ,   CWXP  ,   CWX3  ,   CZXX  ,   
     &               CAXX  ,   CZ3P  ,   CPWW  ,   CPZZ  ,   CXWZ  ,   
     &               CXWA  ,   CPPWW ,   CPPZZ ,   CPXWZ ,   CPXWA ,   
     &               C33WW ,   C33ZZ ,   C3XWZ ,   C3XWA ,   CXXWW 
      COMPLEX*16     CXXZZ ,   CXXAA ,   CXXAZ ,   CPXX  ,   CP33  ,   
     &               CPPP  ,   C3333 ,   CPPPP ,   CXX33 ,   CXXPP ,   
     &               CPP33 ,   CXXXX ,   CXL   ,   CXEL  ,   CXMU  ,   
     &               CXTA  ,   CXQ   ,   CXUQ  ,   CXCQ  ,   CXTQ  ,   
     &               CPLD  ,   CPEL  ,   CPMU  ,   CPTA  ,   CPLU  ,   
     &               CPQU  ,   CPUQ  ,   CPCQ  ,   CPTQ  ,   CPQD  ,   
     &               CPDQ  ,   CPSQ  ,   CPBQ  ,   C3LD  ,   C3EL  ,   
     &               C3MU  ,   C3TA  ,   C3QU  ,   C3UQ  ,   C3CQ  ,   
     &               C3TQ  ,   C3QD  ,   C3DQ  ,   C3SQ  ,   C3BQ  ,   
     &               CWCPZ ,   CWCMZ ,   CWCPA ,   CWCMA ,   CZCMM ,   
     &               CZCPP ,   CACMM ,   CACPP ,   CXCPZ ,   CXCPA ,   
     &               CXCMZ ,   CXCMA ,   C3CPP ,   C3CMM ,   CPCPP 
      COMPLEX*16     CPCMM ,   CPCZZ ,   CQCD  ,   CQQG  ,   CQCDSQ
* Momenta of external particles
      COMMON /A47_AMEXTR/PE0001(4),PE0002(4),PE0003(4),PE0004(4),
     &               PE0005(4),PE0006(4),
     &               PPROD(NEXTRN, NEXTRN)

* Switch of gauge parameters
      COMMON /A47_SMGAUS/IGAU00,IGAUAB,IGAUWB,IGAUZB,IGAUGL
      COMMON /SMGAUG/AGAUGE(0:4)

* Normalization
      COMMON /A47_SMDBGG/FKNORM,FKCALL,NKCALL

* Calculated table of amplitudes
      COMMON /A47_SMATBL/AV, LT, INDEXG
      COMPLEX*16 AV(0:LAG-1)
      INTEGER    LT(0:NEXTRN), INDEXG(NEXTRN)
* For external particles
      COMMON /A47_SMEXTP/
     &    PS0001, EW0001, CE0001
     &   ,PS0002, EW0002, CE0002
     &   ,PS0003, EW0003, CE0003
     &   ,PS0004, EW0004, CE0004
     &   ,PS0005, EW0005, CE0005
     &   ,PS0006, EW0006, CE0006
      REAL*8     PS0001(4,2), EW0001(1)
      COMPLEX*16 CE0001(2,2)
      REAL*8     PS0002(4,2), EW0002(1)
      COMPLEX*16 CE0002(2,2)
      REAL*8     PS0003(4,2), EW0003(1)
      COMPLEX*16 CE0003(2,2)
      REAL*8     PS0004(4,2), EW0004(1)
      COMPLEX*16 CE0004(2,2)
      REAL*8     PS0005(4,2), EW0005(1)
      COMPLEX*16 CE0005(2,2)
      REAL*8     PS0006(4,2), EW0006(1)
      COMPLEX*16 CE0006(2,2)
