      SUBROUTINE FILEXP(XPAR,NPAR)   
!     ***********************************   
! transfers and defines input params, prints input parameters 
      IMPLICIT DOUBLE PRECISION  (A-H,O-Z)  
      DIMENSION  XPAR( *),NPAR( *)          
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF  
      COMMON / WEKIN2 / AMAW,GAMMW,GMU,ALPHAW
! This common contains parameters of non-established particles such as higgs
! Which need to be used by pre-sampler (to be activated by dipswitch IHIG
      COMMON / WEKIN3 / AMHIG,GAMHIG,IHIG
! This common can be everywhere, contains various switches
      COMMON / KeyKey /  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
! TAUOLA, PHOTOS and JETSET overall switches
      COMMON / LIBRA  / JAK1,JAK2,ITDKRC,IFPHOT,IFHADM,IFHADP

      COMMON / VVREC  / VVMIN,VVMAX,VV,BETI                   
      COMMON / WGTGEN /WTMAX,WTMAX4F(20),WTVES,WTYFS,WTSS,WTBWIG,WTBORN      
      COMMON / WGTALL / WTCRUD,WTMOD,WTSET(100)      
      COMMON / DECDAT / AMAFIN(20), BR(20), ICOD(20)
      COMMON / decdatz / brz(20), icodz(20)
      COMMON / INOUT  / NINP,NOUT     
      COMMON / MATPAR / PI,CEULER     
      COMMON / PHYPAR / ALFINV,GPICOB     
      COMMON / WorZ   / probw,probz,ifwon,ifzon,ifWnow,icwm,icwp
!   --Anomalous WWV Couplings, for WWamgc only
      COMMON / ancoco / g1(2),kap(2),lam(2),g4(2),g5(2),kapt(2),lamt(2)
      COMPLEX*16 g1,kap,lam,g4,g5,kapt,lamt
!   --Formats for anyone
      COMMON / BXFMTS / BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G 
      CHARACTER*80      BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G       
      CHARACTER*80      BXL2C      
      COMMON / RANPAR / KEYRND
!   -- upspeeding
      COMMON /upspeed/ FACWEL,FACZEL
      SAVE   /upspeed/     
      SAVE / WEKING /,/ KEYkey /,/ VVREC  /
      SAVE / INOUT  /,/ BXFMTS /,/ RANPAR /,/ WEKIN2 /,/WEKIN3/
      SAVE  / ancoco /,/ decdatz /,/ WorZ   /
      SAVE

!-- Data
      CHARACTER*64 Logo(35)
      DATA Logo /
     $'***************************************************************',
     $'***************************************************************',
     $'***************************************************************',
     $'*  ###   ###                                   ###       ###  *',
     $'*  ###  ###  ####    ######      ##     ##     ###       ###  *',
     $'*  ### ###  ##  ##   ##   ##    ####    ##     ###       ###  *',
     $'*  ######  ##    ##  ##   ##   ##  ##   ##     ###       ###  *',
     $'*  ######  ##    ##  #####    ##    ##  ##     ###   #   ###  *',
     $'*  ### ###  ##  ##   ##  ##   ########  ##      ### ### ###   *',
     $'*  ###  ###  ####    ##   ##  ##    ##  #######  #### ####    *',
     $'*  ###   ###            version 1.33              ##   ##     *',
     $'***************************************************************',
     $'*********************** June    1997 **************************',
     $'***************************************************************',
     $'  Last modification: 04.06.97  final states e+e-ch+ch- at work ',
     $'***************************************************************',
     $'*  Written by:                                                *',
     $'*    M. Skrzypek    (skrzypek@hpjmiady.ifj.edu.pl)            *',
     $'*    S. Jadach      (jadach@cernvm.cern.ch),                  *',
     $'*    W. Placzek     (placzek@hephp02.phys.utk.edu),           *',
     $'*    Z. Was         (wasm@cernvm.cern.ch)                     *',
     $'*  Papers:                                                    *',
     $'*    M. Skrzypek, S. Jadach, W. Placzek, Z. Was               *',
     $'*      preprint CERN-TH/95-205, July 1995, CPC 94 (1996) 216  *',
     $'*    M. Skrzypek, S. Jadach, M. Martinez, W. Placzek, Z. Was  *',
     $'*      preprint CERN-TH/95-246, September 1995,               *',
     $'*      Phys. Lett. B372 (1996) 289.                           *',
     $'*  WWW:                                                       *',
     $'*    http://hpjmiady.ifj.edu.pl/                              *',
     $'*  Acknowledgements:                                          *',
     $'*    We acknowledge warmly very useful help of:               *',
     $'*    M. Martinez in testing versions 1.01 and 1.02,           *',
     $'*    M. Gruenewald and A. Valassi in testing version 1.21     *',
     $'*    S. Jezequel in testing versions 1.31-1.33                *',
     $'***************************************************************',
     $' '/ 

! ...BX-formats for nice and flexible outputs                 
      BXOPE =  '(//1X,15(5H*****)    )'     
      BXTXT =  '(1X,1H*,                  A48,25X,    1H*)'   
      BXL1I =  '(1X,1H*,I17,                 16X, A20,A12,A7, 1X,1H*)'
      BXL1F =  '(1X,1H*,F17.8,               16X, A20,A12,A7, 1X,1H*)' 
      BXL2F =  '(1X,1H*,F17.8, 4H  +-, F11.8, 1X, A20,A12,A7, 1X,1H*)'
      BXL2C ='(1X,1H*,1H(,F14.8,3H +i,F13.7,1H),1X,A20,A12,A7,1X,1H*)'
      BXL1G =  '(1X,1H*,G17.8,               16X, A20,A12,A7, 1X,1H*)'
      BXL2G =  '(1X,1H*,G17.8, 4H  +-, G11.5, 1X, A20,A12,A7, 1X,1H*)'
      BXCLO =  '(1X,15(5H*****)/   )'       

C.. math. constants
      PI=3.1415926535897932D0
      CEULER = 0.57721566D0                  
      ZET2= PI**2/6D0  
      ZET3= 1.2020569031595942854D0       
C.. phys. constants
!     ALFINV  = 137.03604D0
      alfinv  = 137.0359895D0
!     GPICOB =  389.385D6    
      gpicob =  389.37966d6 
c.. electron mass for QED 
!     AMEL   = 0.5111D-3   
      amel   = 0.51099906d-3

C  type of the RANDOM NUMBER GENERATOR RANMAR                   

!-----------------------------------------------------------------------
! Physics switches 
! KeyRad =  1000*KeyCul+100*KeyNLL+10*KeyFSR+KeyISR
      KeyRad = NPAR(1)
      KeyISR = MOD(KeyRad,10)
      KeyFSR = MOD(KeyRad,100)/10
      KeyNLL = MOD(KeyRad,1000)/100
      KeyCul = MOD(KeyRad,10000)/1000
!
! KeyPhy = 100000*KeyWu +10000*KeyRed +1000*KeySpn 
!                       +100*KeyZet +10*KeyMas +KeyBra
      KeyPhy = NPAR(2)
      KeyBra = MOD(KeyPhy,10)
      KeyMas = MOD(KeyPhy,100)/10
      KeyZet = MOD(KeyPhy,1000)/100
      KeySpn = MOD(KeyPhy,10000)/1000
      KeyRed = MOD(KeyPhy,100000)/10000
      KeyWu  = MOD(KeyPhy,1000000)/100000
!-----------------------------------------------------------------------
! Technical switches
! KeyTek = 100*KeySmp +10*KeyRnd +KeyWgt
      KeyTek = NPAR(3)
      KeyWgt = MOD(KeyTek,10)
      KeyRnd = MOD(KeyTek,100)/10
      KeySmp = MOD(KeyTek,1000)/100 
!-----------------------------------------------------------------------
! Miscelaneous, for future develoment
! KeyMis = 10000*KeyWon +1000*KeyZon+100*KeyAcc +10*Key4f +KeyMix
      KeyMis = NPAR(4)
      KeyMix = MOD(KeyMis,10)
      Key4f  = MOD(KeyMis,100)/10
      KeyAcc = MOD(KeyMis,1000)/100
      KeyZon = MOD(KeyMis,10000)/1000
      KeyWon = MOD(KeyMis,100000)/10000
      ifwon= KeyWon
      ifzon= KeyZon
! Higgs pre-sampler dipswitch
      IHIG=0
!-----------------------------------------------------------------------
!
      KEYDWM = NPAR(5)     
      KEYDWP = NPAR(6)     

      if((KeyWon*KeyZon*(KEYDWP+KEYDWM).ne.0).or.
     $   (KeyWon.eq.0.and.KeyZon.eq.0       )     ) then
          write(6,*)'FILEXP==> inconsistent input: '
          write(6,*) 'KeyWon=',KeyWon,'KeyZon=',KeyZon
          write(6,*) 'KeyDWP=',KeyDWP,'KeyDWM=',KeyDWM
          STOP

      endif
      NOUT = NPAR(7)
      IF(nout.LE.0) nout=16     

      JAK1 = NPAR(21)
      JAK2 = NPAR(22)
      ITDKRC = NPAR(23)
      IFPHOT = NPAR(24)
      IFHADM = NPAR(25)
      IFHADP = NPAR(26)


      CMSENE = XPAR(1)      
      GMU    = XPAR(2)   
      ALFWIN = XPAR(3)
      AMAZ   = XPAR(4)
      GAMMZ  = XPAR(5)
      AMAW   = XPAR(6)
      GAMMW  = XPAR(7)
      VVMIN  = XPAR(8)
      VVMAX  = XPAR(9)
      WTMAX  = XPAR(10)
      AMHIG  = XPAR(11)
      GAMHIG = XPAR(12)
      ENE    = CMSENE/2D0      
      VVMAX  = MIN(VVMAX,1D0-(AMEL/ENE)**2)                   
      XPAR(9) =VVMAX ! send it back !!!
      IDE=2               
      IDF=2               
      XK0=3.D-3         

c.. sinw2 is calculated from gmu,alfwin,amaz
      A2 = PI / ( ALFWIN*SQRT(2D0)*GMU )
      SINW2 = ( 1-SQRT( 1-(4*A2/AMAZ**2) ) )/2D0  

c.. alpha_w
      ALPHAW = 1D0/ ALFWIN
!-----------------------------------------------------------------------
!-- sinw2 electroweak mixing angle
      IF(KeyMix .EQ. 1) THEN
         A2 = PI / ( ALFWIN*SQRT(2D0)*GMU )
         SINW2 = ( 1-SQRT( 1-(4*A2/AMAZ**2) ) )/2D0 
      ELSEIF(KeyMix .EQ. 2) THEN
         SINW2 = 1D0 -AMAW**2/AMAZ**2
      ELSE 
!-- new definition for LEP200 workshop
         sinw2 = pi * alphaw /( sqrt(2d0) * amaw**2 * gmu )
      ENDIF
!-----------------------------------------------------------------------
!-- W width recalculated on request
         ALPHA_S=0d0
      IF ( gammw .LE. 0d0 ) THEN
         ASPI=ALPHA_S/PI
         gwc  =  9d0 * Gmu * amaw**2 /( 6d0 * sqrt(2d0) * pi)
         GWC=GWC*(1D0+2D0/3D0*ASPI)  ! <=====================
         gammw = amaw * gwc
         XPAR(7) = GAMMW  ! send it back !!!
      ENDIF
!-----------------------------------------------------------------------

c.. wtmax for rejections
!      if(wtmax.le.0d0) then
!! old!!!
!        WTMAX=6D0
!c        IF(CMSENE.GT.140) WTMAX=5.5D0
!        IF(CMSENE.GT.160) WTMAX=4.4D0
!        IF(CMSENE.GT.170) WTMAX=3.6D0
!        IF(CMSENE.GT.250) WTMAX=4.6D0
!        IF(CMSENE.GT.350) WTMAX=7.0D0
!        IF(CMSENE.GT.700) WTMAX=9.0D0
!        XPAR(10) = WTMAX   ! send it back !!!
!      endif

!--. decays
! Branching ratios for W decay channels:
! 1-ud, 2-cd, 3-us, 4-cs, 5-ub, 6-cb, 7-e, 8-mu, 9-tau
      IF(  KeyBra .EQ. 0 )THEN
         BR(1)=(1D0/3D0)*(1D0+ASPI)/(1D0+2D0/3D0*ASPI) !  <== ud
         BR(2)=0D0                                     !  <== cd
         BR(3)=0D0                                     !  <== us
         BR(4)=(1D0/3D0)*(1D0+ASPI)/(1D0+2D0/3D0*ASPI) !  <== cs
         BR(5)=0D0                                     !  <== ub
         BR(6)=0D0                                     !  <== cb
         BR(7)=(1D0/9D0)           /(1D0+2D0/3D0*ASPI) !  <== e
         BR(8)=(1D0/9D0)           /(1D0+2D0/3D0*ASPI) !  <== mu
         BR(9)=(1D0/9D0)           /(1D0+2D0/3D0*ASPI) !  <== tau
      ELSE
         BR(1)=0.32110D0
         BR(2)=0.01630D0
         BR(3)=0.01635D0
         BR(4)=0.32043D0
         BR(5)=0.00002D0
         BR(6)=0.00070D0
         BR(7)=0.1084D0
         BR(8)=0.1084D0
         BR(9)=0.1083D0
      ENDIF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         FACWEL=1d0
         FACZEL=1d0
         if(key4f.eq.1)  then
          FACWEL=7d0
          br(7)=br(7)*FACWEL
          WRITE(*,*)
     $   'WARNING(1): W-electron br(7) enriched by factor ',FACWEL
          WRITE(*,*)
     $   'this operation does not change results; it is for'
          WRITE(*,*)
     $   ' program optimalization only.'
          WRITE(*,*)
     $   'WARNING(2):It also makes semianalytical results bizzare.'

         FACZEL=48d0!21d0
         WRITE(*,*)
     $   'WARNING(1): Z-electron brz(6) enriched by factor ',FACZEL
         WRITE(*,*)
     $   'this operation does not change results; it is for'
         WRITE(*,*)
     $   ' program optimalization only.'
         WRITE(*,*)
     $   'WARNING(2):It also makes semianalytical results bizzare.'

         endif

         probw=0
         do k=1,9
           probw=probw+br(k)
         enddo
         do k=1,9
           br(k)=br(k)/probw
         enddo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         probw=1
         probh=0.5d0-1.5d0*br(8)
         probh=0.5d0*(1d0-br(7)-br(8)-br(9))

         probz=6d0*br(8)+5d0*probh
         if(key4f.eq.1) probz=(5d0+FACZEL)*br(8)+5d0*probh
         do k=6,11
          brz(k)=br(8)/probz
         enddo
         if(key4f.eq.1)  brz(6)=brz(6)*FACZEL
         do k=1,5
          brz(k)=probh/probz
         enddo
         probz=probz**2
         probw=1d0/(1d0+probz)
         probz=probz/(1d0+probz)
! final fermions masses
      IF(  KeyMas .EQ. 0 ) THEN
         AMAFIN(1)= 0d0
         AMAFIN(2)= 0d0
         AMAFIN(3)= 0d0
         AMAFIN(4)= 0d0
         AMAFIN(5)= 0d0
         
         AMAFIN(11)= 0d0
         AMAFIN(12)= 0d0
         AMAFIN(13)= 0d0
         AMAFIN(14)= 0d0
         AMAFIN(15)= 0d0
         AMAFIN(16)= 0d0
      ELSEIF(  KeyMas .EQ. 1 )THEN
         AMAFIN(1)= 10D-3       ! d -1/3
         AMAFIN(2)= 5D-3        ! u +2/3
         AMAFIN(3)= .2D0        ! s -1/3
         AMAFIN(4)=1.3D0        ! c +2/3
         AMAFIN(5)=4.3D0        ! b -1/3
         
         AMAFIN(11)=.51099906D-3       ! e
         AMAFIN(12)=1d-3!  0D0         ! ve
         AMAFIN(13)=.105658389D0 ! mu
         AMAFIN(14)=1d-3!  0D0         ! vmu
         AMAFIN(15)=1.7771D0    ! tau
         AMAFIN(16)=1d-3!  0D0         ! vtau
      ELSE
         write(6,*) ' +++++++ wrong KeyMas= ', KeyMas
         STOP
      ENDIF
      if(wtmax.le.0d0) then
        WTMAX=7D0
        IF(CMSENE.GT.162) WTMAX=5.0D0
        IF(CMSENE.GT.175) WTMAX=4.0D0
        IF(CMSENE.GT.200) WTMAX=4.4D0
        IF(CMSENE.GT.250) WTMAX=4.8D0
        IF(CMSENE.GT.350) WTMAX=7.0D0
        IF(CMSENE.GT.700) WTMAX=9.0D0
!!!!!
        ifWnow=ifwon
        BNORDI=  BNORL2(2)
!
        FNOR=4D0*(4*pi*alphaw)**2   *(4*pi*alphaw/2/sinw2)**2
     $/((2*pi)**(4)  *  2**5)*1D0/8D0*(2*PI)**3  *BNORDI
        FKeySmp=5
        IF(KeySmp.NE.0) FNOR=FNOR*FKeySmp
        WRITE(*,*) 'temporary print: FNOR=',FNOR,bnordi,FKeySmp
        WRITE(6,*) 'temporary print: FNOR=',FNOR,bnordi,FKeySmp
        WTMAX=WTMAX*FNOR
!!!!!
        XPAR(10) = WTMAX   ! send it back !!!
      endif

c.. wtmax for 4fermion rejections
      do i4f=1,20
        wtmax4f(i4f)=1d0
      enddo

!
      WRITE(6,   '(10X,A)') Logo
      WRITE(NOUT,'(10X,A)') Logo

      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) '           KORALW input parameters used    '
      WRITE(NOUT,BXL1F) CMSENE,     'CMS energy total   ','CMSENE','I.0'
      WRITE(NOUT,BXTXT)'***********************************************'
      WRITE(NOUT,BXL1I) KeyRad,     'QED super-switch   ','KeyRad','IQ1'
      WRITE(NOUT,BXL1I) KeyISR,     'Init. state Rad.   ','KeyISR','IQ2'
      WRITE(NOUT,BXL1I) KeyFSR,     'Final state Rad.   ','KeyFSR','IQ3'
      WRITE(NOUT,BXL1I) KeyNLL,     'Next. To Leading   ','KeyNLL','IQ4'
      WRITE(NOUT,BXL1I) KeyCul,     'Coulomb corr.      ','KeyCul','IQ5'
      WRITE(NOUT,BXTXT)'***********************************************'
      WRITE(NOUT,BXL1I) KeyPhy,     'Physics super-switc','KeyPhy','IP1'
      WRITE(NOUT,BXL1I) KeyRed,     'FS mass reduction  ','KeyRed','IP2'
      WRITE(NOUT,BXL1I) KeySpn,     'Spin in W decays   ','KeySpn','IP3'
      WRITE(NOUT,BXL1I) KeyZet,     'Z propag.          ','KeyZet','IP4'
      WRITE(NOUT,BXL1I) KeyMas,     'Mass kinematics.   ','KeyMas','IP5'
      WRITE(NOUT,BXL1I) KeyBra,     'Branching Rat.     ','KeyBra','IP6'
      WRITE(NOUT,BXL1I) KeyWu,      'W propag.          ','KeyWu ','IP7'
      WRITE(NOUT,BXTXT)'***********************************************'
      WRITE(NOUT,BXL1I) KeyTek,     'Technical super-swi','KeyTek','IT1'
      WRITE(NOUT,BXL1I) KeySmp,     'presampler type    ','KeySmp','IT2'
      WRITE(NOUT,BXL1I) KeyRnd,     'rand Numb type     ','KeyRnd','IT3'
      WRITE(NOUT,BXL1I) KeyWgt,     'weighting  switch  ','KeyWgt','IT4'
      WRITE(NOUT,BXTXT)'***********************************************'
      WRITE(NOUT,BXL1I) KeyMis,     'Miscelaneous       ','KeyMis','IM1'
      WRITE(NOUT,BXL1I) KeyMix,     'sinW2 input type   ','KeyMix','IM2'
      WRITE(NOUT,BXL1I) Key4f,      '4 fermion matr el  ','Key4f ','IM3'
      WRITE(NOUT,BXL1I) KeyAcc,     'Anomalous couplings','KeyAcc','IM4'
      WRITE(NOUT,BXL1I) IFWON ,     'WW type final stats','IFWON ','IM5'
      WRITE(NOUT,BXL1I) IFZON ,     'ZZ type final stats','IFZON ','IM6'
      WRITE(NOUT,BXTXT)'***********************************************'
      WRITE(NOUT,BXL1F) GMU*1d5,    'G_mu * 1d5         ','GMU   ','I.1'
      WRITE(NOUT,BXL1F) ALFWIN,     'inv alpha_w        ','ALFWIN','I.2'
      WRITE(NOUT,BXL1F) AMAZ,       'Z mass   [GeV]     ','AMAZ  ','I.3'
      WRITE(NOUT,BXL1F) GAMMZ,      'Z width  [GeV]     ','GAMMZ ','I.4'
      WRITE(NOUT,BXL1F) AMAW,       'W mass   [GeV]     ','AMAW  ','I.5'
      WRITE(NOUT,BXL1F) GAMMW,      'W width  [GeV]     ','GAMMW ','I.6'
      WRITE(NOUT,BXL1F) VVMIN,      'dummy infrared cut ','VVMIN ','I.7'

      WRITE(NOUT,BXL1F) VVMAX,      'v_max ( =1 )       ','VVMAX ','I.8'
      WRITE(NOUT,BXL1I) KEYDWM,     'W- decay mode      ','KEYDWM','I.9'
      WRITE(NOUT,BXL1I) KEYDWP,     'W+ decay mode      ','KEYDWP','I10'
      WRITE(NOUT,BXL1F) WTMAX,      'max wt for rejectn.','WTMAX ','I11'
      WRITE(NOUT,BXTXT)'for CMSENE < 160--170 GeV: WTMAX  needs change '
      WRITE(NOUT,BXTXT)'***********************************************'
      WRITE(NOUT,BXL1F) SINW2,      'sin(theta_W)**2    ','SINW2 ','I12'
      WRITE(NOUT,BXTXT)'***********************************************'
!-----------------------------------------------------------------------
! Feynman rules and their printout, LEP200 style
!-----------------------------------------------------------------------
      QE =-1
      VEI= 1-4*SINW2
      AEI= 1
      EEW = SQRT(4D0*PI*ALPHAW)
      GAE =-EEW/sqrt(16D0*SinW2*(1d0-SinW2))
      GVE = GAE*VEI
      GWF = EEW/(2D0*sqrt(2d0)*sqrt(SinW2))
      GWWG= EEW
      GWWZ= EEW * sqrt(1d0-SinW2) /sqrt(SinW2)
!-----------------------------------------------------------------------
      WRITE(NOUT,BXL1F) GVE,        'LEP200 workshop      ','GVE ','***'
      WRITE(NOUT,BXL1F) GAE,        'LEP200 workshop      ','GAE ','***'
      WRITE(NOUT,BXL1F) GWF,        'LEP200 workshop      ','GWF ','***'
      WRITE(NOUT,BXL1F) GWWG,       'LEP200 workshop      ','GWWG','***'
      WRITE(NOUT,BXL1F) GWWZ,       'LEP200 workshop      ','GWWZ','***'
      WRITE(NOUT,BXTXT)'***********************************************'
c>    WRITE(NOUT,BXTXT) '       sin(th_W) from G_mu, alpha_w and M_Z: '
c>    WRITE(NOUT,BXTXT) '        A2 = PI / ( ALFWIN*SQRT(2D0)*GMU )   '
c>    WRITE(NOUT,BXTXT) '     SINW2 = ( 1-SQRT( 1-(4*A2/AMAZ**2) ) )/2'
c>    WRITE(NOUT,BXL1F) SINW2,      'sin(theta_W)**2    ','SINW2 ','A6'
c>    WRITE(NOUT,BXTXT)'***********************************************'
      IF(keyzet.eq.0) THEN 
        WRITE(NOUT,BXTXT) '  Z width in Z propagator: s/M_Z *GAMM_Z '
      ELSEIF(keyzet.eq.1) THEN 
        WRITE(NOUT,BXTXT) '  Z width in Z propagator:   M_Z *GAMM_Z '
      ELSEIF(keyzet.eq.2) THEN 
        WRITE(NOUT,BXTXT) '  Z width in Z propagator:   0           '
      ELSE
        WRITE(NOUT,BXTXT) '  FILEXP ==> wrong KEYZET =',keyzet
        STOP
      ENDIF
      WRITE(NOUT,BXTXT)'***********************************************'
      IF(keyspn.ne.1) THEN 
        WRITE(NOUT,BXTXT) '         WARNING!  spin in decays is OFF: '
        WRITE(NOUT,BXL1I) KEYSPN, 'spin in decays switch','KEYSPN','A13'
      WRITE(NOUT,BXTXT)'***********************************************'
      ENDIF
      WRITE(NOUT,BXTXT) '                                             '
      WRITE(NOUT,BXTXT) '                                      DECAYS:'
      WRITE(NOUT,BXTXT) '                            branching ratios:'
      WRITE(NOUT,BXL1F) BR(1),            'ud','BR(1)','IB1'
      WRITE(NOUT,BXL1F) BR(2),            'cd','BR(2)','IB2'
      WRITE(NOUT,BXL1F) BR(3),            'us','BR(3)','IB3'
      WRITE(NOUT,BXL1F) BR(4),            'cs','BR(4)','IB4'
      WRITE(NOUT,BXL1F) BR(5),            'ub','BR(5)','IB5'
      WRITE(NOUT,BXL1F) BR(6),            'cb','BR(6)','IB6'
      WRITE(NOUT,BXL1F) BR(7),            ' e','BR(7)','IB7'
      if (facwel.ne.1d0)
     $WRITE(NOUT,BXL1F) facwel,'e special: enchanc.','factor','IB7'
      WRITE(NOUT,BXL1F) BR(8),           ' mu','BR(8)','IB8'
      WRITE(NOUT,BXL1F) BR(9),          ' tau','BR(9)','IB9'
      WRITE(NOUT,BXTXT) 'Dummy Branching ratios of Z decays:          '
      WRITE(NOUT,BXL1F) BRZ(1),            ' d','BRZ(1)','IZ1'
      WRITE(NOUT,BXL1F) BRZ(2),            ' u','BRZ(2)','IZ2'
      WRITE(NOUT,BXL1F) BRZ(3),            ' s','BRZ(3)','IZ3'
      WRITE(NOUT,BXL1F) BRZ(4),            ' c','BRZ(4)','IZ4'
      WRITE(NOUT,BXL1F) BRZ(5),            ' b','BRZ(5)','IZ5'
      WRITE(NOUT,BXL1F) BRZ(6),            ' e','BRZ(6)','IZ6'
      if (faczel.ne.1d0)
     $WRITE(NOUT,BXL1F) faczel,'e special: enchanc.','factor','IZ6'
      WRITE(NOUT,BXL1F) BRZ(7),           ' mu','BRZ(7)','IZ7'
      WRITE(NOUT,BXL1F) BRZ(8),          ' tau','BRZ(8)','IZ8'
      WRITE(NOUT,BXL1F) BRZ(9),            've','BRZ(9)','IZ9'
      WRITE(NOUT,BXL1F) BRZ(10),        'vmu','BRZ(10)','IZ10'
      WRITE(NOUT,BXL1F) BRZ(11),       'vtau','BRZ(11)','IZ11'

      WRITE(NOUT,BXTXT) '                                      masses:'
      WRITE(NOUT,BXL1F) AMAFIN(1),     ' d','AMAFIN(1)','IM1'
      WRITE(NOUT,BXL1F) AMAFIN(2),     ' u','AMAFIN(2)','IM2'
      WRITE(NOUT,BXL1F) AMAFIN(3),     ' s','AMAFIN(3)','IM3'
      WRITE(NOUT,BXL1F) AMAFIN(4),     ' c','AMAFIN(4)','IM4'
      WRITE(NOUT,BXL1F) AMAFIN(5),     ' b','AMAFIN(5)','IM5'
      WRITE(NOUT,BXL1F) AMAFIN(11),    ' e','AMAFIN(11)','IM6'
      WRITE(NOUT,BXL1F) AMAFIN(12),    've','AMAFIN(12)','IM7'
      WRITE(NOUT,BXL1F) AMAFIN(13),    'mu','AMAFIN(13)','IM8'
      WRITE(NOUT,BXL1F) AMAFIN(14),   'vmu','AMAFIN(14)','IM9'
      WRITE(NOUT,BXL1F) AMAFIN(15),   'tau','AMAFIN(15)','IM10'
      WRITE(NOUT,BXL1F) AMAFIN(16),  'vtau','AMAFIN(16)','IM11'
      WRITE(NOUT,BXTXT) '                                             '

      IF(keyacc.ne.0) THEN 
        IF(key4f.ne.0) THEN 
      WRITE(NOUT,BXTXT)'***********************************************'
          WRITE(NOUT,BXTXT) '                 '
          WRITE(NOUT,BXTXT) 'WARNING! Internal anomalous couplings and'
          WRITE(NOUT,BXTXT) ' external matrix element are both active.'
          WRITE(NOUT,BXTXT) '          Proceed with caution ?         '
          WRITE(NOUT,BXTXT) '          Sorry, noo way yet. I stop ....'
      WRITE(NOUT,BXTXT)'***********************************************'
          stop
        ENDIF     
!----------------------------------------------------------------------!
! Setting up the anomalous couplings as given in the paper:            !
!     K. Hagiwara, R.D. Peccei, D. Zeppenfeld and K. Hikasa,           !
!                 Nucl. Phys. B282 (1987) 253.                         !
! The variables used in this routine correspond to the following       !
! contants defined in the above paper:                                 !
!           constant name     corresponding variable                   ! 
!                g_1^V                g1(2)                            !
!                kappa_V              kap(2)                           !
!                lambda_V             lam(2)                           !
!                g_4^V                g4(2)                            !
!                g_5^V                g5(2)                            !
!                kappa-tilde_V        kapt(2)                          !
!                lambda-tilde_V       lamt(2)                          ! 
!----------------------------------------------------------------------!      

         IF(keyACC .EQ. 1) THEN 
!       --Set up constants OTHER than SM:
!       --for WWgamma vertex
          g1(1)   = DCMPLX(xpar(21),xpar(31))
          kap(1)  = DCMPLX(xpar(22),xpar(32))
          lam(1)  = DCMPLX(xpar(23),xpar(33))
          g4(1)   = DCMPLX(xpar(24),xpar(34))
          g5(1)   = DCMPLX(xpar(25),xpar(35))
          kapt(1) = DCMPLX(xpar(26),xpar(36))
          lamt(1) = DCMPLX(xpar(27),xpar(37))
!       --WWZ vertex
          g1(2)   = DCMPLX(xpar(41),xpar(51))
          kap(2)  = DCMPLX(xpar(42),xpar(52))
          lam(2)  = DCMPLX(xpar(43),xpar(53))
          g4(2)   = DCMPLX(xpar(44),xpar(54))
          g5(2)   = DCMPLX(xpar(45),xpar(55))
          kapt(2) = DCMPLX(xpar(46),xpar(56))
          lamt(2) = DCMPLX(xpar(47),xpar(57))
        ELSE
          write(6,*)'FILEXP==> Wrong KeyAcc: ',keyacc
          STOP
        ENDIF
!
        WRITE(NOUT,BXTXT)'Internal Anomalous Couplings Activated'
        WRITE(NOUT,BXTXT)'Convention from:'
        WRITE(NOUT,BXTXT)
     $         'K.Hagiwara, R.D.Peccei, D.Zeppenfeld, K.Hikasa,'
        WRITE(NOUT,BXTXT)'                Nucl. Phys. B282 (1987) 253.'
        WRITE(NOUT,BXTXT)'                        for WWZ vertex'  
        WRITE(NOUT,BXL2C) g1(2),             'g_1^Z','g1(2)  ','IC21'
        WRITE(NOUT,BXL2C) kap(2),          'kappa_Z','kap(2) ','IC22'
        WRITE(NOUT,BXL2C) lam(2),         'lambda_Z','lam(2) ','IC23' 
        WRITE(NOUT,BXL2C) g4(2),             'g_4^Z','g4(2)  ','IC24'
        WRITE(NOUT,BXL2C) g5(2),             'g_5^Z','g5(2)  ','IC25'     
        WRITE(NOUT,BXL2C) kapt(2),   'kappa-tilde_Z','kapt(2)','IC26'       
        WRITE(NOUT,BXL2C) lamt(2),  'lambda-tilde_Z','lamt(2)','IC27'          
        WRITE(NOUT,BXTXT)'                    for WWg vertex (gamma)'  
        WRITE(NOUT,BXL2C) g1(1),             'g_1^g','g1(1)  ','IC21'
        WRITE(NOUT,BXL2C) kap(1),          'kappa_g','kap(1) ','IC22'
        WRITE(NOUT,BXL2C) lam(1),         'lambda_g','lam(1) ','IC23' 
        WRITE(NOUT,BXL2C) g4(1),             'g_4^g','g4(1)  ','IC24'
        WRITE(NOUT,BXL2C) g5(1),             'g_5^g','g5(1)  ','IC25'     
        WRITE(NOUT,BXL2C) kapt(1),   'kappa-tilde_g','kapt(1)','IC26'       
        WRITE(NOUT,BXL2C) lamt(1),  'lambda-tilde_g','lamt(1)','IC27'          
        WRITE(NOUT,BXTXT)' '
      ENDIF

      WRITE(NOUT,BXTXT) '                              DECAY LIBRARIES'
      WRITE(NOUT,BXL1I) JAK1,         'TAUOLA for W+' ,'JAK1','IL1'
      WRITE(NOUT,BXL1I) JAK2,         'TAUOLA for W-' ,'JAK2','IL2'
      WRITE(NOUT,BXL1I) ITDKRC,   'TAUOLA Ord(alpha)' ,'ITDKRC','IL3'
      WRITE(NOUT,BXL1I) IFPHOT,              'PHOTOS' ,'IFPHOT','IL4'
      WRITE(NOUT,BXL1I) IFHADM,       'JETSET for W-' ,'IFHADM','IL5'
      WRITE(NOUT,BXL1I) IFHADP,       'JETSET for W+' ,'IFHADP','IL6'
      WRITE(NOUT,BXCLO)         


      END       





